"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; } function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }var __require = /* @__PURE__ */ ((x) => typeof require !== "undefined" ? require : typeof Proxy !== "undefined" ? new Proxy(x, {
  get: (a, b) => (typeof require !== "undefined" ? require : a)[b]
}) : x)(function(x) {
  if (typeof require !== "undefined")
    return require.apply(this, arguments);
  throw Error('Dynamic require of "' + x + '" is not supported');
});

// src/index.ts
var _magicstring = require('magic-string'); var _magicstring2 = _interopRequireDefault(_magicstring);

// src/babel-helpers/ast.ts

















var _types = require('@babel/types');

// src/constants.ts
var DEFINE_COMPONENT_HELPER = "defineComponent";
var USE_DEFAULTS_HELPER = "useDefaults";
var TO_REFS_HELPER = "toRefs";
var USE_MODEL_HELPER = "useModel";
var CSS_VARS_HELPER = "useCssVars";
var USE_SLOT_HELPER = "useSlots";
var UN_REF_HELPER = "unref";
var DEFAULT_MODEL_MODIFIERS_NAME = "modelModifiers";
var BARE_CALL_MACROS = [
  "vineExpose",
  "vineOptions",
  "vineStyle",
  "vineStyle.scoped",
  "vineCustomElement"
];
var VINE_MACROS = [
  "vineProp",
  "vineProp.optional",
  "vineProp.withDefault",
  "vineEmits",
  "vineSlots",
  "vineModel",
  ...BARE_CALL_MACROS
];
var CAN_BE_CALLED_MULTI_TIMES_MACROS = [
  "vineModel"
];
var SUPPORTED_CSS_LANGS = ["css", "scss", "sass", "less", "stylus", "postcss"];
var TS_NODE_TYPES = [
  "TSAsExpression",
  // foo as number
  "TSTypeAssertion",
  // (<number>foo)
  "TSNonNullExpression",
  // foo!
  "TSInstantiationExpression",
  // foo<string>
  "TSSatisfiesExpression"
  // foo satisfies T
];
var VineBindingTypes = {
  /**
   * declared as a prop
   */
  PROPS: "props",
  /**
   * a local alias of a `<script setup>` destructured prop.
   * the original is stored in __propsAliases of the bindingMetadata object.
   */
  PROPS_ALIASED: "props-aliased",
  /**
   * a let binding (may or may not be a ref)
   */
  SETUP_LET: "setup-let",
  /**
   * a const binding that can never be a ref.
   * these bindings don't need `unref()` calls when processed in inlined
   * template expressions.
   */
  SETUP_CONST: "setup-const",
  /**
   * a const binding that does not need `unref()`, but may be mutated.
   */
  SETUP_REACTIVE_CONST: "setup-reactive-const",
  /**
   * a const binding that may be a ref.
   */
  SETUP_MAYBE_REF: "setup-maybe-ref",
  /**
   * bindings that are guaranteed to be refs
   */
  SETUP_REF: "setup-ref",
  /**
   * a literal constant, e.g. 'foo', 1, true
   */
  LITERAL_CONST: "literal-const"
};
var EXPECTED_ERROR = "expected_error";

// src/babel-helpers/ast.ts
function isVineCompFnDecl(target) {
  if ((_types.isExportNamedDeclaration.call(void 0, target) || _types.isExportDefaultDeclaration.call(void 0, target)) && target.declaration) {
    target = target.declaration;
  }
  if (_types.isFunctionDeclaration.call(void 0, target) || _types.isVariableDeclaration.call(void 0, target)) {
    try {
      _types.traverse.call(void 0, target, (node) => {
        if (_types.isReturnStatement.call(void 0, node) && node.argument && isVineTaggedTemplateString(node.argument)) {
          throw new Error(EXPECTED_ERROR);
        }
      });
    } catch (error) {
      if (error.message === EXPECTED_ERROR) {
        return true;
      }
      throw error;
    }
  }
  return false;
}
function findVineCompFnDecls(root) {
  const vineFnComps = [];
  for (const stmt of root.program.body) {
    if (isVineCompFnDecl(stmt)) {
      vineFnComps.push(stmt);
    }
  }
  return vineFnComps;
}
function isDescendant(node, potentialDescendant) {
  const stack = [node];
  while (stack.length) {
    const currentNode = stack.pop();
    if (currentNode === potentialDescendant) {
      return true;
    }
    const children = Object.values(currentNode).filter((child) => Array.isArray(child) ? child.every(_types.isNode) : _types.isNode.call(void 0, child));
    for (const child of children) {
      if (Array.isArray(child)) {
        stack.push(...child);
      } else {
        stack.push(child);
      }
    }
  }
  return false;
}
function isVineTaggedTemplateString(node) {
  return _types.isTaggedTemplateExpression.call(void 0, node) && _types.isIdentifier.call(void 0, node.tag) && node.tag.name === "vine";
}
function isVineMacroCallExpression(node) {
  if (_types.isCallExpression.call(void 0, node)) {
    const callee = node.callee;
    if (_types.isIdentifier.call(void 0, callee)) {
      return VINE_MACROS.includes(callee.name);
    }
    if (_types.isMemberExpression.call(void 0, callee)) {
      const obj = callee.object;
      const prop = callee.property;
      if (_types.isIdentifier.call(void 0, obj) && _types.isIdentifier.call(void 0, prop)) {
        return VINE_MACROS.includes(
          `${obj.name}.${prop.name}`
        );
      }
    }
  }
  return false;
}
function getVineMacroCalleeName(node) {
  const callee = node.callee;
  if (_types.isIdentifier.call(void 0, callee)) {
    return callee.name;
  }
  if (_types.isMemberExpression.call(void 0, callee)) {
    const obj = callee.object;
    const prop = callee.property;
    if (_types.isIdentifier.call(void 0, obj) && _types.isIdentifier.call(void 0, prop)) {
      return `${obj.name}.${prop.name}`;
    }
  }
  return "";
}
function isVineMacroOf(name) {
  return (node) => {
    if (_types.isCallExpression.call(void 0, node)) {
      const callee = node.callee;
      if (_types.isIdentifier.call(void 0, callee)) {
        return Array.isArray(name) ? name.includes(callee.name) : callee.name === name;
      }
      if (_types.isMemberExpression.call(void 0, callee)) {
        const obj = callee.object;
        const prop = callee.property;
        if (_types.isIdentifier.call(void 0, obj) && _types.isIdentifier.call(void 0, prop)) {
          return Array.isArray(name) ? name.some((n) => `${obj.name}.${prop.name}`.includes(n)) : `${obj.name}.${prop.name}`.includes(name);
        }
        return false;
      }
    }
    return false;
  };
}
var isVineProp = isVineMacroOf("vineProp");
var isVineSlots = isVineMacroOf("vineSlots");
var isVineEmits = isVineMacroOf("vineEmits");
var isVineModel = isVineMacroOf("vineModel");
var isVineStyle = isVineMacroOf("vineStyle");
var isVineCustomElement = isVineMacroOf("vineCustomElement");
function isStatementContainsVineMacroCall(node) {
  let result = false;
  _types.traverse.call(void 0, node, (descendant) => {
    if (isVineMacroCallExpression(descendant)) {
      result = true;
    }
  });
  return result;
}
function isTagTemplateStringContainsInterpolation(tagTmplNode) {
  return tagTmplNode.quasi.expressions.length > 0;
}
function getFunctionParams(fnItselfNode) {
  const params = [];
  if (_types.isFunctionDeclaration.call(void 0, fnItselfNode)) {
    params.push(...fnItselfNode.params);
  } else if (_types.isFunctionExpression.call(void 0, fnItselfNode) || _types.isArrowFunctionExpression.call(void 0, fnItselfNode)) {
    params.push(...fnItselfNode.params);
  }
  return params;
}
function getFunctionInfo(fnDecl) {
  let fnName = _types.isFunctionDeclaration.call(void 0, fnDecl) ? _nullishCoalesce(_optionalChain([fnDecl, 'access', _2 => _2.id, 'optionalAccess', _3 => _3.name]), () => ( "")) : "";
  let fnItselfNode = _types.isFunctionDeclaration.call(void 0, fnDecl) ? fnDecl : void 0;
  let target = fnDecl;
  if (_types.isExportNamedDeclaration.call(void 0, target) && target.declaration) {
    target = target.declaration;
  }
  if (_types.isFunctionDeclaration.call(void 0, target)) {
    fnItselfNode = target;
    fnName = _nullishCoalesce(_optionalChain([target, 'access', _4 => _4.id, 'optionalAccess', _5 => _5.name]), () => ( ""));
  } else if (_types.isVariableDeclaration.call(void 0, target) && ((_types.isFunctionExpression.call(void 0, target.declarations[0].init) || _types.isArrowFunctionExpression.call(void 0, target.declarations[0].init)) && _types.isIdentifier.call(void 0, target.declarations[0].id))) {
    fnItselfNode = target.declarations[0].init;
    fnName = target.declarations[0].id.name;
  }
  return {
    fnItselfNode,
    fnName
  };
}
function findVineTagTemplateStringReturn(node) {
  let templateReturn;
  let templateStringNode;
  _types.traverse.call(void 0, node, (descendant) => {
    if (_types.isReturnStatement.call(void 0, descendant)) {
      templateReturn = descendant;
      if (isVineTaggedTemplateString(descendant.argument)) {
        templateStringNode = descendant.argument;
      }
    }
  });
  return {
    templateReturn,
    templateStringNode
  };
}
function getImportStatements(root) {
  const importStmts = [];
  for (const stmt of root.program.body) {
    if (_types.isImportDeclaration.call(void 0, stmt)) {
      importStmts.push(stmt);
    }
  }
  return importStmts;
}
function getTSTypeLiteralPropertySignatureName(tsTypeLit) {
  return _types.isIdentifier.call(void 0, tsTypeLit.key) ? tsTypeLit.key.name : _types.isStringLiteral.call(void 0, tsTypeLit.key) ? tsTypeLit.key.value : "";
}
function getAllVinePropMacroCall(fnItselfNode) {
  const allVinePropMacroCalls = [];
  _types.traverse.call(void 0, fnItselfNode.body, {
    enter(node, parent) {
      if (!isVineMacroOf("vineProp")(node)) {
        return;
      }
      const propVarDeclarator = parent.find((ancestor) => _types.isVariableDeclarator.call(void 0, ancestor.node) && _types.isIdentifier.call(void 0, ancestor.node.id));
      if (!propVarDeclarator) {
        return;
      }
      const propVarIdentifier = propVarDeclarator.node.id;
      allVinePropMacroCalls.push([node, propVarIdentifier]);
    }
  });
  return allVinePropMacroCalls;
}
function unwrapTSNode(node) {
  if (TS_NODE_TYPES.includes(node.type)) {
    return unwrapTSNode(node.expression);
  } else {
    return node;
  }
}
function isStaticNode(node) {
  node = unwrapTSNode(node);
  switch (node.type) {
    case "UnaryExpression":
      return isStaticNode(node.argument);
    case "LogicalExpression":
    case "BinaryExpression":
      return isStaticNode(node.left) && isStaticNode(node.right);
    case "ConditionalExpression": {
      return isStaticNode(node.test) && isStaticNode(node.consequent) && isStaticNode(node.alternate);
    }
    case "SequenceExpression":
    case "TemplateLiteral":
      return node.expressions.every((expr) => isStaticNode(expr));
    case "ParenthesizedExpression":
      return isStaticNode(node.expression);
    case "StringLiteral":
    case "NumericLiteral":
    case "BooleanLiteral":
    case "NullLiteral":
    case "BigIntLiteral":
      return true;
  }
  return false;
}
function isCallOf(node, test) {
  return !!(node && test && node.type === "CallExpression" && node.callee.type === "Identifier" && (typeof test === "string" ? node.callee.name === test : test(node.callee.name)));
}
function isLiteralNode(node) {
  return node.type.endsWith("Literal");
}
function canNeverBeRef(node, userReactiveImport) {
  if (isCallOf(node, userReactiveImport)) {
    return true;
  }
  switch (node.type) {
    case "UnaryExpression":
    case "BinaryExpression":
    case "ArrayExpression":
    case "ObjectExpression":
    case "FunctionExpression":
    case "ArrowFunctionExpression":
    case "UpdateExpression":
    case "ClassExpression":
    case "TaggedTemplateExpression":
      return true;
    case "SequenceExpression":
      return canNeverBeRef(
        node.expressions[node.expressions.length - 1],
        userReactiveImport
      );
    default:
      if (isLiteralNode(node)) {
        return true;
      }
      return false;
  }
}

// src/validate.ts
var _process = require('process'); var _process2 = _interopRequireDefault(_process);

















// src/utils/color-string.ts
var colorMap = {
  bold: "1",
  italic: "3",
  underline: "4",
  inverse: "7",
  strikethrough: "9",
  white: "37",
  grey: "90",
  black: "30",
  blue: "34",
  cyan: "36",
  green: "32",
  magenta: "35",
  red: "31",
  yellow: "33",
  bgWhite: "47",
  bgGrey: "49",
  bgBlack: "40",
  bgBlue: "44",
  bgCyan: "46",
  bgGreen: "42",
  bgMagenta: "45",
  bgRed: "41",
  bgYellow: "43"
};
function colorful(str, options = []) {
  const colors = options.map((option) => {
    return colorMap[option];
  }).join(";");
  return `\x1B[${colors}m${str}\x1B[0m`;
}
function createColorful(options) {
  return (str) => colorful(str, options);
}
var Colorful = Object.keys(colorMap).reduce((acc, key) => {
  acc[key] = createColorful([key]);
  return acc;
}, {});

// src/diagnostics.ts
var whiteFgRedBg = createColorful(["white", "bgRed"]);
var whiteFgYellowBg = createColorful(["white", "bgYellow"]);
var redFgBold = createColorful(["red", "bold"]);
var ErrorLabel = whiteFgRedBg(" Error ");
var WarningLabel = whiteFgYellowBg(" Warning ");
function makeDiagnostic(label, { msg, fileId, location, msgColorful }) {
  const pos = _optionalChain([location, 'optionalAccess', _6 => _6.start]);
  const posString = pos ? `${pos.line}:${pos.column}` : "";
  return `
${label} File: ${fileId} ${posString}
${msgColorful(msg)}
`;
}
function vineErr(vineFileCtx, { msg, location }) {
  const full = makeDiagnostic(ErrorLabel, {
    msg,
    fileId: vineFileCtx.fileId,
    location,
    msgColorful: redFgBold
  });
  return { full, msg, location };
}
function vineWarn(vineFileCtx, { msg, location }) {
  const full = makeDiagnostic(WarningLabel, {
    msg,
    fileId: vineFileCtx.fileId,
    location,
    msgColorful: whiteFgYellowBg
  });
  return { full, msg, location };
}

// src/utils/index.ts


// src/utils/makeMap.ts
function makeMap(str, expectsLowerCase) {
  const map = /* @__PURE__ */ Object.create(null);
  const list = str.split(",");
  for (let i = 0; i < list.length; i++) {
    map[list[i]] = true;
  }
  return expectsLowerCase ? (val) => !!map[val.toLowerCase()] : (val) => !!map[val];
}

// src/utils/index.ts
var camelizeRE = /-(\w)/g;
function cacheStringFunction(fn) {
  const cache = /* @__PURE__ */ Object.create(null);
  return (str) => {
    const hit = cache[str];
    return hit || (cache[str] = fn(str));
  };
}
function showIf(condition, s, not) {
  return condition ? s : _nullishCoalesce(not, () => ( ""));
}
function filterJoin(arr, join) {
  return arr.filter(Boolean).join(join);
}
function getStyleLangFileExt(styleLang) {
  if (styleLang === "postcss") {
    return "css";
  } else if (styleLang === "stylus") {
    return "styl";
  }
  return styleLang;
}
function appendToMapArray(storeMap, key, value) {
  const arr = storeMap.get(key);
  if (!arr) {
    storeMap.set(key, [value]);
  } else {
    arr.push(value);
  }
}
var camelize = cacheStringFunction((str) => {
  return str.replace(camelizeRE, (_, c) => c ? c.toUpperCase() : "");
});
var capitalize = cacheStringFunction(
  (str) => str.charAt(0).toUpperCase() + str.slice(1)
);
var isBuiltInDirective = /* @__PURE__ */ makeMap(
  "bind,cloak,else-if,else,for,html,if,model,on,once,pre,show,slot,text,memo"
);
var ExitTraverseError = class extends Error {
  constructor() {
    super("ExitTraverse");
  }
};
var exitTraverse = new ExitTraverseError();
var _breakableTraverse = (node, handlers) => {
  try {
    return _types.traverse.call(void 0, node, handlers);
  } catch (e) {
    if (e instanceof ExitTraverseError) {
      return;
    }
    throw e;
  }
};

// src/validate.ts
function wrapVineValidatorWithLog(validators) {
  return _process2.default.env.VINE_DEV_VITEST === "true" ? validators.map((validator) => (...args) => {
    const isPass = validator(...args);
    console.log(`${colorful(" VINE VALIDATE ", ["bgGreen", "white"])} ${validator.name} => ${colorful(isPass ? "PASS" : "FAIL", [isPass ? "green" : "red"])}`);
    return isPass;
  }) : validators;
}
function vitestLogMacroAssert(macroName, isPass) {
  if (_process2.default.env.VINE_DEV_VITEST !== "true") {
    return;
  }
  console.log(`${colorful(" VINE MACRO ASSERT ", ["bgMagenta", "white"])} ${macroName} => ${colorful(isPass ? "PASS" : "FAIL", [isPass ? "green" : "red"])}`);
}
function validateNoOutsideMacroCalls({ vineCompilerHooks, vineFileCtx, vineCompFns }, root) {
  let isMacroInsideVineCompFn = true;
  _types.traverse.call(void 0, root, (node) => {
    if (!isVineMacroCallExpression(node)) {
      return;
    }
    isMacroInsideVineCompFn = vineCompFns.some(
      (vineCompFn) => isDescendant(vineCompFn, node)
    );
    if (!isMacroInsideVineCompFn) {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: "Vine macro calls must be inside Vue Vine component function!",
            location: node.loc
          }
        )
      );
    }
  });
  return isMacroInsideVineCompFn;
}
function validateVineTemplateStringUsage({ vineCompilerHooks, vineFileCtx }, vineCompFn) {
  let isVineTemplateUsagePass = true;
  let vineTemplateStrCount = 0;
  _types.traverse.call(void 0, vineCompFn, (node) => {
    if (!isVineTaggedTemplateString(node)) {
      return;
    }
    vineTemplateStrCount += 1;
    if (vineTemplateStrCount > 1) {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: "Multiple vine tagged template are not allowed inside Vine component function",
            location: node.loc
          }
        )
      );
      isVineTemplateUsagePass = false;
    }
    if (isTagTemplateStringContainsInterpolation(node)) {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: "Vine template string are not allowed to contain interpolation!",
            location: node.loc
          }
        )
      );
      isVineTemplateUsagePass = false;
    }
  });
  return isVineTemplateUsagePass;
}
function assertVineStyleUsage({ vineCompilerHooks, vineFileCtx }, vineStyleMacroCallNode) {
  const vineStyleArgsLength = vineStyleMacroCallNode.arguments.length;
  const macroCallee = vineStyleMacroCallNode.callee;
  if (vineStyleArgsLength !== 1) {
    vineCompilerHooks.onError(
      vineErr(
        vineFileCtx,
        {
          msg: `\`vineStyle\` ${vineStyleArgsLength > 1 ? "can only" : "must"} have one string argument'`,
          location: macroCallee.loc
        }
      )
    );
    return false;
  }
  const theOnlyArg = vineStyleMacroCallNode.arguments[0];
  if (_types.isStringLiteral.call(void 0, theOnlyArg)) {
  } else if (_types.isTemplateLiteral.call(void 0, theOnlyArg)) {
    if (theOnlyArg.expressions.length > 0) {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: "vineStyle argument must be a plain string, template string interpolation is not allowed",
            location: theOnlyArg.loc
          }
        )
      );
      return false;
    }
  } else if (_types.isTaggedTemplateExpression.call(void 0, theOnlyArg)) {
    if (theOnlyArg.tag && _types.isIdentifier.call(void 0, theOnlyArg.tag) && !SUPPORTED_CSS_LANGS.includes(theOnlyArg.tag.name)) {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: "vineStyle CSS language only supports: `css`, `scss`, `sass`, `less`, `stylus` and `postcss`",
            location: theOnlyArg.tag.loc
          }
        )
      );
      return false;
    }
  } else {
    vineCompilerHooks.onError(
      vineErr(
        vineFileCtx,
        {
          msg: "vineStyle's argument can only be string",
          location: theOnlyArg.loc
        }
      )
    );
    return false;
  }
  return true;
}
function assertMacroCanOnlyHaveOneObjLiteralArg({ vineCompilerHooks, vineFileCtx }, macroCallNode) {
  const macroCallArgsLength = macroCallNode.arguments.length;
  const macroCallee = macroCallNode.callee;
  const errMsg = `\`${macroCallee.name}\` ${macroCallArgsLength > 1 ? "can only" : "must"} have one object literal argument`;
  if (macroCallArgsLength === 1) {
    const theOnlyArg = macroCallNode.arguments[0];
    if (!_types.isObjectExpression.call(void 0, theOnlyArg)) {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: errMsg,
            location: theOnlyArg.loc
          }
        )
      );
      return false;
    }
  } else {
    vineCompilerHooks.onError(
      vineErr(
        vineFileCtx,
        {
          msg: errMsg,
          location: macroCallee.loc
        }
      )
    );
    return false;
  }
  return true;
}
function assertMacroCanOnlyHaveOneTypeParam({ vineCompilerHooks, vineFileCtx }, macroCallNode) {
  const macroCallee = macroCallNode.callee;
  const typeParams = _optionalChain([macroCallNode, 'access', _7 => _7.typeParameters, 'optionalAccess', _8 => _8.params]);
  const typeParamsLength = _optionalChain([typeParams, 'optionalAccess', _9 => _9.length]);
  const errMsg = `\`${macroCallee.name}\` ${typeParamsLength && typeParamsLength > 1 ? "can only" : "must"} have 1 type parameter`;
  if (typeParamsLength !== 1) {
    vineCompilerHooks.onError(
      vineErr(
        vineFileCtx,
        {
          msg: errMsg,
          location: macroCallNode.callee.loc
        }
      )
    );
    return false;
  }
  return true;
}
function assertMacroVariableDeclarationMustBeIdentifier({ vineCompilerHooks, vineFileCtx }, macroName, macroCallNode, parent, { isMustBeInsideVarDecl } = { isMustBeInsideVarDecl: false }) {
  const varDeclaratorThatMayBeInside = _optionalChain([parent, 'optionalAccess', _10 => _10.find, 'call', _11 => _11((ancestor) => _types.isVariableDeclarator.call(void 0, ancestor.node))]);
  if (varDeclaratorThatMayBeInside) {
    const varDeclThatMayBeInsideNode = varDeclaratorThatMayBeInside.node;
    if (!_types.isIdentifier.call(void 0, varDeclThatMayBeInsideNode.id)) {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: `the declaration of macro \`${macroName}\` call must be an identifier`,
            location: varDeclThatMayBeInsideNode.id.loc
          }
        )
      );
      return false;
    }
  } else if (isMustBeInsideVarDecl) {
    vineCompilerHooks.onError(
      vineErr(
        vineFileCtx,
        {
          msg: `the declaration of \`${macroName}\` macro call must be inside a variable declaration`,
          location: macroCallNode.loc
        }
      )
    );
    return false;
  }
  return true;
}
function assertVineEmitsUsage(validatorCtx, macroCallNode, parent) {
  const { vineCompilerHooks, vineFileCtx } = validatorCtx;
  let isVineEmitsUsageCorrect = true;
  if (!assertMacroCanOnlyHaveOneTypeParam(validatorCtx, macroCallNode)) {
    isVineEmitsUsageCorrect = false;
  } else {
    const typeParams = _optionalChain([macroCallNode, 'access', _12 => _12.typeParameters, 'optionalAccess', _13 => _13.params]);
    const theOnlyTypeParam = _optionalChain([typeParams, 'optionalAccess', _14 => _14[0]]);
    if (!_types.isTSTypeLiteral.call(void 0, theOnlyTypeParam)) {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: "Vue Vine component function's vineEmits type must be object literal!",
            location: _optionalChain([theOnlyTypeParam, 'optionalAccess', _15 => _15.loc])
          }
        )
      );
      isVineEmitsUsageCorrect = false;
    }
    const properties = _optionalChain([theOnlyTypeParam, 'optionalAccess', _16 => _16.members]);
    if (!properties.every((prop) => _types.isTSPropertySignature.call(void 0, prop))) {
      isVineEmitsUsageCorrect = false;
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: "Vue Vine component function's vineEmits type must be object literal! And all properties' key must be string literal or identifier",
            location: _optionalChain([theOnlyTypeParam, 'optionalAccess', _17 => _17.loc])
          }
        )
      );
    }
  }
  if (!assertMacroVariableDeclarationMustBeIdentifier(
    validatorCtx,
    "vineEmits",
    macroCallNode,
    parent
  )) {
    isVineEmitsUsageCorrect = false;
  }
  return isVineEmitsUsageCorrect;
}
function assertSlotMethodSignature(validatorCtx, methodSignature) {
  const { vineCompilerHooks, vineFileCtx } = validatorCtx;
  const params = methodSignature.parameters;
  const errMsg = "Function signature of `vineSlots` definition can only have one parameter named `props`";
  if (params.length !== 1) {
    vineCompilerHooks.onError(
      vineErr(
        vineFileCtx,
        {
          msg: errMsg,
          location: methodSignature.loc
        }
      )
    );
    return false;
  }
  const theSignatureOnlyParam = params[0];
  let isNameNotProps = false;
  if (!_types.isIdentifier.call(void 0, theSignatureOnlyParam) || (isNameNotProps = theSignatureOnlyParam.name !== "props")) {
    vineCompilerHooks.onError(
      vineErr(
        vineFileCtx,
        {
          msg: `${errMsg}${isNameNotProps ? `, and its parameter name must be \`props\`, but got \`${theSignatureOnlyParam.name}\`` : ""}`,
          location: theSignatureOnlyParam.loc
        }
      )
    );
    return false;
  }
  const paramTypeAnnotation = _optionalChain([theSignatureOnlyParam, 'access', _18 => _18.typeAnnotation, 'optionalAccess', _19 => _19.typeAnnotation]);
  if (!paramTypeAnnotation || !_types.isTSTypeLiteral.call(void 0, paramTypeAnnotation)) {
    vineCompilerHooks.onError(
      vineErr(
        vineFileCtx,
        {
          msg: `${errMsg}, and its type annotation must be object literal`,
          location: theSignatureOnlyParam.loc
        }
      )
    );
    return false;
  }
  return true;
}
function assertSlotPropertySignature(validatorCtx, propertySignature) {
  const { vineCompilerHooks, vineFileCtx } = validatorCtx;
  const typeAnnotation = _optionalChain([propertySignature, 'access', _20 => _20.typeAnnotation, 'optionalAccess', _21 => _21.typeAnnotation]);
  if (!typeAnnotation || !_types.isTSFunctionType.call(void 0, typeAnnotation)) {
    vineCompilerHooks.onError(
      vineErr(
        vineFileCtx,
        {
          msg: "Properties of `vineSlots` can only have function type annotation",
          location: propertySignature.loc
        }
      )
    );
    return false;
  }
  const params = typeAnnotation.parameters;
  const errMsg = "Function signature of `vineSlots` can only have one parameter named `props`";
  const firstParam = params[0];
  if (params.length !== 1 || !_types.isIdentifier.call(void 0, firstParam)) {
    vineCompilerHooks.onError(
      vineErr(
        vineFileCtx,
        {
          msg: errMsg,
          location: typeAnnotation.loc
        }
      )
    );
    return false;
  }
  const paramTypeAnnotation = _optionalChain([firstParam, 'access', _22 => _22.typeAnnotation, 'optionalAccess', _23 => _23.typeAnnotation]);
  if (!paramTypeAnnotation || !_types.isTSTypeLiteral.call(void 0, paramTypeAnnotation)) {
    vineCompilerHooks.onError(
      vineErr(
        vineFileCtx,
        {
          msg: `${errMsg}, and its type annotation must be object literal`,
          location: firstParam.loc
        }
      )
    );
    return false;
  }
  return true;
}
function assertVineSlotsUsage(validatorCtx, macroCallNode, parent) {
  const { vineCompilerHooks, vineFileCtx } = validatorCtx;
  let isVineSlotsUsageCorrect = true;
  if (!assertMacroCanOnlyHaveOneTypeParam(validatorCtx, macroCallNode)) {
    isVineSlotsUsageCorrect = false;
  } else {
    const typeParams = _optionalChain([macroCallNode, 'access', _24 => _24.typeParameters, 'optionalAccess', _25 => _25.params]);
    const theOnlyTypeParam = _optionalChain([typeParams, 'optionalAccess', _26 => _26[0]]);
    if (!_types.isTSTypeLiteral.call(void 0, theOnlyTypeParam)) {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: "Vue Vine component function's vineSlots type must be object literal!",
            location: _optionalChain([theOnlyTypeParam, 'optionalAccess', _27 => _27.loc])
          }
        )
      );
      isVineSlotsUsageCorrect = false;
    }
    const slotSignatures = _nullishCoalesce(_optionalChain([theOnlyTypeParam, 'optionalAccess', _28 => _28.members]), () => ( []));
    if (!slotSignatures.every((prop) => {
      if (_types.isTSMethodSignature.call(void 0, prop))
        return true;
      if (_types.isTSPropertySignature.call(void 0, prop) && _types.isTSFunctionType.call(void 0, _optionalChain([prop, 'access', _29 => _29.typeAnnotation, 'optionalAccess', _30 => _30.typeAnnotation]))) {
        return true;
      }
      return false;
    })) {
      isVineSlotsUsageCorrect = false;
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: "Every property of Vue Vine component function's `vineSlots` type must be function signature",
            location: _optionalChain([theOnlyTypeParam, 'optionalAccess', _31 => _31.loc])
          }
        )
      );
    }
    slotSignatures.forEach((signature) => {
      if (_types.isTSMethodSignature.call(void 0, signature) && !assertSlotMethodSignature(validatorCtx, signature)) {
        isVineSlotsUsageCorrect = false;
      } else if (_types.isTSPropertySignature.call(void 0, signature) && !assertSlotPropertySignature(validatorCtx, signature)) {
        isVineSlotsUsageCorrect = false;
      }
    });
  }
  if (!assertMacroVariableDeclarationMustBeIdentifier(
    validatorCtx,
    "vineSlots",
    macroCallNode,
    parent
  )) {
    isVineSlotsUsageCorrect = false;
  }
  return isVineSlotsUsageCorrect;
}
function assertVineModelDefaultDuplicated(validatorCtx, modelCtx, macroCallNode, extraAssert) {
  const { vineCompilerHooks, vineFileCtx } = validatorCtx;
  const macroCallArgs = macroCallNode.arguments;
  const isAlreadyHasDefault = modelCtx.hasDefaultModel;
  let isThisOneAsDefault = false;
  const isExtraAssertValid = Object.values(extraAssert).every(Boolean);
  if (_optionalChain([macroCallArgs, 'optionalAccess', _32 => _32.length]) === 0 && isExtraAssertValid) {
    isThisOneAsDefault = true;
  } else if (_optionalChain([macroCallArgs, 'optionalAccess', _33 => _33.length]) === 1 && _types.isObjectExpression.call(void 0, macroCallArgs[0]) && isExtraAssertValid) {
    isThisOneAsDefault = true;
  }
  if (isThisOneAsDefault) {
    if (isAlreadyHasDefault) {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: "Vue Vine component function can only have one default model",
            location: macroCallNode.loc
          }
        )
      );
      return false;
    }
    modelCtx.hasDefaultModel = true;
  }
  return true;
}
function assertVineModelUsage(validatorCtx, modelCtx, macroCallNode, parent) {
  const { vineCompilerHooks, vineFileCtx } = validatorCtx;
  let isVineModelUsageCorrect = true;
  const typeParams = _optionalChain([macroCallNode, 'access', _34 => _34.typeParameters, 'optionalAccess', _35 => _35.params]);
  const macroCallArgs = macroCallNode.arguments;
  const lastArg = _optionalChain([macroCallArgs, 'optionalAccess', _36 => _36[macroCallArgs.length - 1]]);
  if (_optionalChain([typeParams, 'optionalAccess', _37 => _37.length]) === 0) {
    if (_optionalChain([macroCallArgs, 'optionalAccess', _38 => _38.length]) === 0) {
    } else if (_types.isObjectExpression.call(void 0, lastArg) && !lastArg.properties.some((prop) => {
      if (_types.isObjectProperty.call(void 0, prop) && _types.isIdentifier.call(void 0, prop.key) && prop.key.name === "default") {
        return true;
      }
      return false;
    })) {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: "If `vineModel` macro call doesn't have type parameter, it must have a `default` field in the options object literal",
            location: lastArg.loc
          }
        )
      );
      isVineModelUsageCorrect = false;
    }
  }
  let isInsideVarDecl = false;
  if (!assertMacroVariableDeclarationMustBeIdentifier(
    validatorCtx,
    "vineModel",
    macroCallNode,
    parent,
    {
      isMustBeInsideVarDecl: true
    }
  )) {
    isVineModelUsageCorrect = false;
  } else {
    isInsideVarDecl = true;
  }
  if (_optionalChain([macroCallArgs, 'optionalAccess', _39 => _39.length]) > 2) {
    vineCompilerHooks.onError(
      vineErr(
        vineFileCtx,
        {
          msg: "`vineModel` macro call can only have at most 2 arguments",
          location: macroCallNode.loc
        }
      )
    );
    isVineModelUsageCorrect = false;
  } else {
    isVineModelUsageCorrect = assertVineModelDefaultDuplicated(
      validatorCtx,
      modelCtx,
      macroCallNode,
      {
        isInsideVarDecl
      }
    );
  }
  return isVineModelUsageCorrect;
}
function validateMacrosUsage(validatorCtx, vineCompFn) {
  const { vineCompilerHooks, vineFileCtx } = validatorCtx;
  const macroCountMap = {
    vineStyle: {
      count: 0,
      asserts: [
        assertVineStyleUsage
      ]
    },
    vineEmits: {
      count: 0,
      asserts: [
        assertVineEmitsUsage
      ]
    },
    vineSlots: {
      count: 0,
      asserts: [
        assertVineSlotsUsage
      ]
    },
    vineExpose: {
      count: 0,
      asserts: [
        assertMacroCanOnlyHaveOneObjLiteralArg
      ]
    },
    vineOptions: {
      count: 0,
      asserts: [
        assertMacroCanOnlyHaveOneObjLiteralArg
      ]
    },
    vineCustomElement: {
      count: 0,
      asserts: []
    }
  };
  let isCountCorrect = true;
  let isBareCallMacrosPass = true;
  _types.traverse.call(void 0, vineCompFn, {
    enter(node, parent) {
      if (!isVineMacroCallExpression(node)) {
        return;
      }
      const macroCalleeName = getVineMacroCalleeName(node);
      if (!macroCalleeName) {
        return;
      }
      const macroName = macroCalleeName.includes(".") ? macroCalleeName.split(".")[0] : macroCalleeName;
      if (macroCountMap[macroName]) {
        macroCountMap[macroName].count += 1;
        macroCountMap[macroName].node = node;
        macroCountMap[macroName].parent = [...parent];
      }
      const VarDeclThatMacroBeInside = parent.find((ancestor) => _types.isVariableDeclaration.call(void 0, ancestor.node));
      if (VarDeclThatMacroBeInside && BARE_CALL_MACROS.includes(macroName)) {
        isBareCallMacrosPass = false;
        vineCompilerHooks.onError(
          vineErr(
            vineFileCtx,
            {
              msg: `\`${macroName}\` macro call is not allowed to be inside a variable declaration`,
              location: _optionalChain([VarDeclThatMacroBeInside, 'optionalAccess', _40 => _40.node, 'access', _41 => _41.loc])
            }
          )
        );
      }
    }
  });
  const macroMoreThanOnce = Object.entries(macroCountMap).filter(([macroName, it]) => {
    if (CAN_BE_CALLED_MULTI_TIMES_MACROS.includes(macroName)) {
      return false;
    }
    return it.count > 1;
  });
  if (macroMoreThanOnce.length > 0) {
    macroMoreThanOnce.forEach(([macroName, it]) => {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: `Multiple \`${macroName}\` calls are not allowed inside Vine component function`,
            location: _optionalChain([it, 'access', _42 => _42.node, 'optionalAccess', _43 => _43.loc])
          }
        )
      );
    });
    isCountCorrect = false;
  }
  const isAssertsPass = Object.entries(macroCountMap).map(
    ([macroName, it]) => it.asserts.map((assert) => {
      const isPass = it.node ? assert(validatorCtx, it.node, it.parent) : true;
      vitestLogMacroAssert(macroName, isPass);
      return isPass;
    }).every(Boolean)
  ).every(Boolean);
  return isCountCorrect && isBareCallMacrosPass && isAssertsPass;
}
function validateVineModel(validatorCtx, vineCompFn) {
  const vineModelMacroCalls = [];
  _breakableTraverse(vineCompFn, (node, parent) => {
    if (isVineModel(node)) {
      vineModelMacroCalls.push({
        macroCall: node,
        parent: [...parent]
      });
    }
  });
  let isVineModelUsageCorrect = true;
  const modelCtx = {
    hasDefaultModel: false
  };
  for (const { macroCall, parent } of vineModelMacroCalls) {
    if (!assertVineModelUsage(
      validatorCtx,
      modelCtx,
      macroCall,
      parent
    )) {
      isVineModelUsageCorrect = false;
    }
  }
  return isVineModelUsageCorrect;
}
function validateVineFunctionCompProps({ vineCompilerHooks, vineFileCtx }, vineCompFnDecl) {
  const { fnItselfNode } = getFunctionInfo(vineCompFnDecl);
  const vineCompFnParams = fnItselfNode ? getFunctionParams(fnItselfNode) : [];
  const vineCompFnParamsLength = vineCompFnParams.length;
  let vinePropMacroCallCount = 0;
  const isCheckVinePropMacroCallPass = () => {
    let isVinePropCheckPass = true;
    _types.traverse.call(void 0, vineCompFnDecl, {
      enter(node, parent) {
        if (!isVineProp(node)) {
          return;
        }
        vinePropMacroCallCount += 1;
        const macroCalleeName = getVineMacroCalleeName(node);
        if (!macroCalleeName) {
          return;
        }
        if (macroCalleeName !== "vineProp.withDefault") {
          const typeParamsLength = _optionalChain([node, 'access', _44 => _44.typeParameters, 'optionalAccess', _45 => _45.params, 'access', _46 => _46.length]);
          if (typeParamsLength !== 1) {
            vineCompilerHooks.onError(
              vineErr(
                vineFileCtx,
                {
                  msg: `\`${macroCalleeName}\` macro call ${typeParamsLength && typeParamsLength > 1 ? "can only" : "must"} have a type parameter to specify the prop's type`,
                  location: node.loc
                }
              )
            );
            isVinePropCheckPass = false;
          }
        } else if (!node.arguments.length) {
          isVinePropCheckPass = false;
          vineCompilerHooks.onError(
            vineErr(
              vineFileCtx,
              {
                msg: `\`${macroCalleeName}\` macro call must have at least 1 argument`,
                location: node.loc
              }
            )
          );
        }
        const parentVarDecl = parent.find((ancestor) => _types.isVariableDeclaration.call(void 0, ancestor.node));
        const parentVarDeclarator = parent.find((ancestor) => _types.isVariableDeclarator.call(void 0, ancestor.node));
        if (!parentVarDecl || !parentVarDeclarator) {
          isVinePropCheckPass = false;
          vineCompilerHooks.onError(
            vineErr(
              vineFileCtx,
              {
                msg: "`vineProp` macro call must be inside a `const` variable declaration",
                location: node.loc
              }
            )
          );
        } else {
          const isConst = parentVarDecl.node.kind === "const";
          if (!isConst) {
            isVinePropCheckPass = false;
            vineCompilerHooks.onError(
              vineErr(
                vineFileCtx,
                {
                  msg: "`vineProp` macro call must be inside a `const` declaration",
                  location: parentVarDecl.node.loc
                }
              )
            );
          }
          const varDeclarator = parentVarDeclarator.node;
          if (!_types.isIdentifier.call(void 0, varDeclarator.id)) {
            isVinePropCheckPass = false;
            vineCompilerHooks.onError(
              vineErr(
                vineFileCtx,
                {
                  msg: "the declaration of `vineProp` macro call must be an identifier",
                  location: varDeclarator.id.loc
                }
              )
            );
          }
        }
      }
    });
    return isVinePropCheckPass;
  };
  if (vineCompFnParamsLength === 0) {
    return isCheckVinePropMacroCallPass();
  } else if (vineCompFnParamsLength === 1) {
    const theOnlyFormalParam = vineCompFnParams[0];
    let isCheckFormalParamsPropPass = true;
    if (!_types.isIdentifier.call(void 0, theOnlyFormalParam)) {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: "If you're defining a Vine component function's props with formal parameter, it must be one and only identifier",
            location: theOnlyFormalParam.loc
          }
        )
      );
      isCheckFormalParamsPropPass = false;
    }
    const theOnlyFormalParamTypeAnnotation = theOnlyFormalParam.typeAnnotation;
    if (!theOnlyFormalParamTypeAnnotation) {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: "Vine component function's props must have a type annotation",
            location: theOnlyFormalParam.loc
          }
        )
      );
      isCheckFormalParamsPropPass = false;
    }
    if (_types.isTSTypeAnnotation.call(void 0, theOnlyFormalParamTypeAnnotation) && _types.isTSTypeLiteral.call(void 0, theOnlyFormalParamTypeAnnotation.typeAnnotation)) {
      const propsTypeAnnotation = theOnlyFormalParamTypeAnnotation.typeAnnotation;
      const isTSTypeAnnotationValid = propsTypeAnnotation.members.every(
        (member) => _types.isTSPropertySignature.call(void 0, member) && (_types.isStringLiteral.call(void 0, member.key) || _types.isIdentifier.call(void 0, member.key))
      );
      if (!isTSTypeAnnotationValid) {
        vineCompilerHooks.onError(
          vineErr(
            vineFileCtx,
            {
              msg: "Vine component function's props type annotation must be an object literal, only contains properties signature, and all properties' key must be string literal or identifier",
              location: propsTypeAnnotation.loc
            }
          )
        );
        isCheckFormalParamsPropPass = false;
      }
    } else {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: "Vine component function's props type annotation must be an object literal",
            location: _optionalChain([theOnlyFormalParamTypeAnnotation, 'optionalAccess', _47 => _47.loc])
          }
        )
      );
      isCheckFormalParamsPropPass = false;
    }
    if (vinePropMacroCallCount > 0) {
      vineCompilerHooks.onError(
        vineErr(
          vineFileCtx,
          {
            msg: "Vine component function's props can only be defined with formal parameter or `vineProp` macro calls, not both",
            location: theOnlyFormalParam.loc
          }
        )
      );
      isCheckFormalParamsPropPass = false;
    }
    if (!isCheckFormalParamsPropPass) {
      isCheckVinePropMacroCallPass();
      return false;
    }
    return isCheckVinePropMacroCallPass();
  }
  vineCompilerHooks.onError(
    vineErr(
      vineFileCtx,
      {
        msg: "Vine component function can only have one parameter",
        location: vineCompFnDecl.loc
      }
    )
  );
  return false;
}
var validatesFromRoot = wrapVineValidatorWithLog([
  validateNoOutsideMacroCalls
]);
var validatesFromVineFn = wrapVineValidatorWithLog([
  validateVineTemplateStringUsage,
  validateMacrosUsage,
  validateVineModel,
  validateVineFunctionCompProps
]);
function createVineValidator(vineCompilerHooks, vineFileCtx, vineCompFns) {
  return (validates, fromNode) => {
    return validates.map(
      (validateFn) => validateFn(
        {
          vineCompilerHooks,
          vineFileCtx,
          vineCompFns
        },
        fromNode
      )
    ).filter(Boolean).length < validates.length;
  };
}
function validateVine(compilerHooks, vineFileCtx, vineCompFnDecls) {
  const findValidateError = createVineValidator(compilerHooks, vineFileCtx, vineCompFnDecls);
  if (findValidateError(validatesFromRoot, vineFileCtx.root)) {
    return false;
  }
  let hasErrInVineCompFns = false;
  for (const vineCompFnDecl of vineCompFnDecls) {
    const hasErr = findValidateError(validatesFromVineFn, vineCompFnDecl);
    if (hasErr)
      hasErrInVineCompFns = hasErr;
  }
  return !hasErrInVineCompFns;
}

// src/analyze.ts
var _hashsum = require('hash-sum'); var _hashsum2 = _interopRequireDefault(_hashsum);
var _compilerdom = require('@vue/compiler-dom');





















// src/style/analyze-css-vars.ts
function lexBinding(content, start) {
  let state = 1 /* inParens */;
  let parenDepth = 0;
  for (let i = start; i < content.length; i++) {
    const char = content.charAt(i);
    switch (state) {
      case 1 /* inParens */:
        if (char === "'") {
          state = 2 /* inSingleQuoteString */;
        } else if (char === '"') {
          state = 3 /* inDoubleQuoteString */;
        } else if (char === "(") {
          parenDepth++;
        } else if (char === ")") {
          if (parenDepth > 0) {
            parenDepth--;
          } else {
            return i;
          }
        }
        break;
      case 2 /* inSingleQuoteString */:
        if (char === "'") {
          state = 1 /* inParens */;
        }
        break;
      case 3 /* inDoubleQuoteString */:
        if (char === '"') {
          state = 1 /* inParens */;
        }
        break;
    }
  }
  return null;
}
function normalizeExpression(exp) {
  exp = exp.trim();
  if (exp[0] === "'" && exp[exp.length - 1] === "'" || exp[0] === '"' && exp[exp.length - 1] === '"') {
    return exp.slice(1, -1);
  }
  return exp;
}
var vBindRE = /v-bind\s*\(/g;
function parseCssVars(styles, hook) {
  const vars = [];
  styles.forEach((style) => {
    let match = null;
    const content = style.replace(/\/\*([\s\S]*?)\*\//g, "");
    for (match = vBindRE.exec(content); match; match = vBindRE.exec(content)) {
      const start = match.index + match[0].length;
      const end = lexBinding(content, start);
      if (end !== null) {
        hook && hook.getIndex(start, end);
        const variable = normalizeExpression(content.slice(start, end));
        if (!vars.includes(variable)) {
          vars.push(variable);
        }
      }
    }
  });
  return vars;
}

// src/template/importUsageCheck.ts
var _parser = require('@babel/parser');





var templateUsageCheckCache = /* @__PURE__ */ new Map();
var forAliasRE = /([\s\S]*?)\s+(?:in|of)\s+([\s\S]*)/;
function resolveTemplateUsageCheckString(content, astRoot) {
  const cached = templateUsageCheckCache.get(content);
  if (cached) {
    return cached;
  }
  let code = "";
  _compilerdom.transform.call(void 0, astRoot, {
    nodeTransforms: [
      (node) => {
        if (node.type === 1) {
          if (!_compilerdom.parserOptions.isNativeTag(node.tag) && !_compilerdom.parserOptions.isBuiltInComponent(node.tag)) {
            code += `,${camelize(node.tag)},${capitalize(camelize(node.tag))}`;
          }
          for (let i = 0; i < node.props.length; i++) {
            const prop = node.props[i];
            if (prop.type === 7) {
              if (!isBuiltInDirective(prop.name)) {
                code += `,v${capitalize(camelize(prop.name))}`;
              }
              if (prop.exp) {
                code += `,${processExp(
                  prop.exp.content,
                  prop.name
                )}`;
              }
            }
          }
        } else if (node.type === 5) {
          code += `,${processExp(
            node.content.content
          )}`;
        }
      }
    ]
  });
  code += ";";
  templateUsageCheckCache.set(content, code);
  return code;
}
function processExp(exp, dir) {
  if (/ as\s+\w|<.*>|:/.test(exp)) {
    if (dir === "slot") {
      exp = `(${exp})=>{}`;
    } else if (dir === "on") {
      exp = `()=>{return ${exp}}`;
    } else if (dir === "for") {
      const inMatch = exp.match(forAliasRE);
      if (inMatch) {
        let [, LHS, RHS] = inMatch;
        LHS = LHS.trim().replace(/^\(|\)$/g, "");
        return processExp(`(${LHS})=>{}`) + processExp(RHS);
      }
    }
    let ret = "";
    const ast = _parser.parseExpression.call(void 0, exp, { plugins: ["typescript"] });
    _compilerdom.walkIdentifiers.call(void 0, ast, (node) => {
      ret += `,${node.name}`;
    });
    return ret;
  }
  return stripStrings(exp);
}
function stripStrings(exp) {
  return exp.replace(/'[^']*'|"[^"]*"/g, "").replace(/`[^`]+`/g, stripTemplateString);
}
function stripTemplateString(str) {
  const interpMatch = str.match(/\${[^}]+}/g);
  if (interpMatch) {
    return interpMatch.map((m) => m.slice(2, -1)).join(",");
  }
  return "";
}
function isImportUsed(vineCompFnCtx, local) {
  return !!vineCompFnCtx.templateAst && new RegExp(
    // Vuejs core #4274 - escape $ since it's a special char in regex
    // (and is the only regex special char that is valid in identifiers)
    `[^\\w$_]${local.replace(/\$/g, "\\$")}[^\\w$_]`
  ).test(
    resolveTemplateUsageCheckString(
      vineCompFnCtx.templateSource,
      vineCompFnCtx.templateAst
    )
  );
}

// src/analyze.ts
function storeTheOnlyMacroCallArg(macroName, callback) {
  const findMacroCallNode = (fnItselfNode) => {
    let vineExposeMacroCall;
    _breakableTraverse(fnItselfNode, {
      enter(descendant) {
        if (isVineMacroOf(macroName)(descendant)) {
          vineExposeMacroCall = descendant;
          throw exitTraverse;
        }
      }
    });
    return vineExposeMacroCall;
  };
  return (analyzeCtx, fnItselfNode) => {
    const macroCall = findMacroCallNode(fnItselfNode);
    if (!macroCall) {
      return;
    }
    const macroCallArg = macroCall.arguments[0];
    if (!macroCallArg) {
      return;
    }
    callback(analyzeCtx, macroCallArg);
  };
}
var analyzeVineExpose = storeTheOnlyMacroCallArg(
  "vineExpose",
  ({ vineCompFnCtx }, macroCallArg) => {
    vineCompFnCtx.expose = macroCallArg;
  }
);
var analyzeVineOptions = storeTheOnlyMacroCallArg(
  "vineOptions",
  ({ vineCompFnCtx }, macroCallArg) => {
    vineCompFnCtx.options = macroCallArg;
  }
);
function registerBinding(bindings, node, type) {
  bindings[node.name] = type;
}
function walkPattern(node, bindings, isConst) {
  if (node.type === "Identifier") {
    const type = isConst ? VineBindingTypes.SETUP_MAYBE_REF : VineBindingTypes.SETUP_LET;
    registerBinding(bindings, node, type);
  } else if (node.type === "RestElement") {
    const type = isConst ? VineBindingTypes.SETUP_CONST : VineBindingTypes.SETUP_LET;
    registerBinding(bindings, node.argument, type);
  } else if (node.type === "ObjectPattern") {
    walkObjectPattern(node, bindings, isConst);
  } else if (node.type === "ArrayPattern") {
    walkArrayPattern(node, bindings, isConst);
  } else if (node.type === "AssignmentPattern") {
    if (node.left.type === "Identifier") {
      const type = isConst ? VineBindingTypes.SETUP_MAYBE_REF : VineBindingTypes.SETUP_LET;
      registerBinding(bindings, node.left, type);
    } else {
      walkPattern(node.left, bindings, isConst);
    }
  }
}
function walkArrayPattern(node, bindings, isConst) {
  for (const e of node.elements) {
    e && walkPattern(e, bindings, isConst);
  }
}
function walkObjectPattern(node, bindings, isConst) {
  for (const p of node.properties) {
    if (p.type === "ObjectProperty") {
      if (p.key.type === "Identifier" && p.key === p.value) {
        const type = isConst ? VineBindingTypes.SETUP_MAYBE_REF : VineBindingTypes.SETUP_LET;
        registerBinding(bindings, p.key, type);
      } else {
        walkPattern(p.value, bindings, isConst);
      }
    } else {
      const type = isConst ? VineBindingTypes.SETUP_CONST : VineBindingTypes.SETUP_LET;
      registerBinding(bindings, p.argument, type);
    }
  }
}
function analyzeVariableDeclarationForBindings({ vineFileCtx, vineCompFnCtx }, stmt) {
  const userImportAliases = { ...vineFileCtx.vueImportAliases };
  const userReactiveBinding = userImportAliases.reactive;
  const allDeclarators = stmt.declarations;
  const isConst = stmt.kind === "const";
  const isAllLiteral = isConst && allDeclarators.every(
    (decl) => _types.isIdentifier.call(void 0, decl.id) && decl.init && isStaticNode(decl.init)
  );
  for (const varDecl of allDeclarators) {
    if (_types.isIdentifier.call(void 0, varDecl.id) && varDecl.init) {
      let bindingType;
      if (isAllLiteral || isConst && isStaticNode(varDecl.init)) {
        bindingType = VineBindingTypes.LITERAL_CONST;
      } else if (isCallOf(varDecl.init, userReactiveBinding)) {
        bindingType = isConst ? VineBindingTypes.SETUP_REACTIVE_CONST : VineBindingTypes.SETUP_LET;
      } else if (
        // if a declaration is a const literal, we can mark it so that
        // the generated render fn code doesn't need to unref() it
        isConst && canNeverBeRef(varDecl.init, userReactiveBinding)
      ) {
        bindingType = VineBindingTypes.SETUP_CONST;
      } else if (isConst) {
        if (isCallOf(
          varDecl.init,
          (m) => m === userImportAliases.ref || m === userImportAliases.computed || m === userImportAliases.shallowRef || m === userImportAliases.customRef || m === userImportAliases.toRef
        )) {
          bindingType = VineBindingTypes.SETUP_REF;
        } else {
          bindingType = VineBindingTypes.SETUP_MAYBE_REF;
        }
      } else {
        bindingType = VineBindingTypes.SETUP_LET;
      }
      registerBinding(vineCompFnCtx.bindings, varDecl.id, bindingType);
    } else if (_types.isObjectPattern.call(void 0, varDecl.id)) {
      walkObjectPattern(
        varDecl.id,
        vineCompFnCtx.bindings,
        isConst
      );
    } else if (_types.isArrayPattern.call(void 0, varDecl.id)) {
      walkArrayPattern(
        varDecl.id,
        vineCompFnCtx.bindings,
        isConst
      );
    }
  }
  return isAllLiteral;
}
function analyzeVineFnBodyStmtForBindings(analyzeCtx, stmt) {
  const { vineCompFnCtx } = analyzeCtx;
  let isAllLiteral = false;
  switch (stmt.type) {
    case "VariableDeclaration":
      isAllLiteral = analyzeVariableDeclarationForBindings(analyzeCtx, stmt);
      break;
    case "TSEnumDeclaration":
      isAllLiteral = stmt.members.every(
        (member) => !member.initializer || isStaticNode(member.initializer)
      );
      vineCompFnCtx.bindings[stmt.id.name] = isAllLiteral ? VineBindingTypes.LITERAL_CONST : VineBindingTypes.SETUP_CONST;
      break;
    case "FunctionDeclaration":
    case "ClassDeclaration":
      vineCompFnCtx.bindings[stmt.id.name] = VineBindingTypes.SETUP_CONST;
      break;
    default:
      break;
  }
  return isAllLiteral;
}
function getVineStyleSource(vineStyleArg) {
  let styleLang = "css";
  let styleSource = "";
  let range;
  if (_types.isTaggedTemplateExpression.call(void 0, vineStyleArg)) {
    const { tag } = vineStyleArg;
    if (_types.isIdentifier.call(void 0, tag)) {
      styleLang = tag.name;
      const styleSourceNode = vineStyleArg.quasi.quasis[0];
      styleSource = styleSourceNode.value.raw;
      range = [styleSourceNode.start, styleSourceNode.end];
    }
  } else if (_types.isStringLiteral.call(void 0, vineStyleArg)) {
    styleSource = vineStyleArg.value;
    range = [vineStyleArg.start, vineStyleArg.end];
  } else if (_types.isTemplateLiteral.call(void 0, vineStyleArg)) {
    const styleSourceNode = vineStyleArg.quasis[0];
    styleSource = styleSourceNode.value.raw;
    range = [styleSourceNode.start, styleSourceNode.end];
  }
  return {
    styleSource,
    styleLang,
    range
  };
}
var analyzeVineProps = ({ vineCompFnCtx, vineFileCtx }, fnItselfNode) => {
  const formalParams = getFunctionParams(fnItselfNode);
  if (formalParams.length === 1) {
    const propsFormalParam = formalParams[0];
    const propsTypeAnnotation = propsFormalParam.typeAnnotation.typeAnnotation;
    vineCompFnCtx.propsAlias = propsFormalParam.name;
    _optionalChain([propsTypeAnnotation, 'access', _48 => _48.members, 'optionalAccess', _49 => _49.forEach, 'call', _50 => _50((member) => {
      if (!_types.isIdentifier.call(void 0, member.key)) {
        return;
      }
      const propName = member.key.name;
      const propType = vineFileCtx.fileMagicCode.slice(
        member.typeAnnotation.typeAnnotation.start,
        member.typeAnnotation.typeAnnotation.end
      );
      const propMeta = {
        isFromMacroDefine: false,
        isRequired: member.optional === void 0 ? true : !member.optional,
        isBool: propType === "boolean"
      };
      vineCompFnCtx.props[propName] = propMeta;
      vineCompFnCtx.bindings[propName] = VineBindingTypes.PROPS;
    })]);
  } else if (formalParams.length === 0) {
    const allVinePropMacroCalls = getAllVinePropMacroCall(fnItselfNode);
    allVinePropMacroCalls.forEach(([macroCall, propVarIdentifier]) => {
      const macroCalleeName = getVineMacroCalleeName(macroCall);
      const propMeta = {
        isFromMacroDefine: true,
        isRequired: macroCalleeName !== "vineProp.optional",
        isBool: false
      };
      const macroCallTypeParamNode = _optionalChain([macroCall, 'access', _51 => _51.typeParameters, 'optionalAccess', _52 => _52.params, 'access', _53 => _53[0]]);
      if (macroCallTypeParamNode) {
        const macroCallTypeParam = vineFileCtx.fileMagicCode.slice(
          macroCallTypeParamNode.start,
          macroCallTypeParamNode.end
        );
        propMeta.isBool = macroCallTypeParam === "boolean";
      }
      if (macroCalleeName === "vineProp.withDefault") {
        propMeta.default = macroCall.arguments[0];
        propMeta.validator = macroCall.arguments[1];
      } else {
        propMeta.validator = macroCall.arguments[0];
      }
      const propName = propVarIdentifier.name;
      vineCompFnCtx.props[propName] = propMeta;
      vineCompFnCtx.bindings[propName] = VineBindingTypes.SETUP_REF;
    });
  }
};
var analyzeVineEmits = (analyzeCtx, fnItselfNode) => {
  const { vineCompFnCtx } = analyzeCtx;
  let vineEmitsMacroCall;
  let parentVarDecl;
  _breakableTraverse(fnItselfNode, {
    enter(descendant, parent) {
      if (isVineEmits(descendant)) {
        vineEmitsMacroCall = descendant;
        const foundVarDeclAncestor = parent.find((ancestor) => _types.isVariableDeclarator.call(void 0, ancestor.node));
        parentVarDecl = _optionalChain([foundVarDeclAncestor, 'optionalAccess', _54 => _54.node]);
        throw exitTraverse;
      }
    }
  });
  if (!vineEmitsMacroCall) {
    return;
  }
  const typeParam = _optionalChain([vineEmitsMacroCall, 'access', _55 => _55.typeParameters, 'optionalAccess', _56 => _56.params, 'access', _57 => _57[0]]);
  if (!typeParam) {
    return;
  }
  const emitsTypeLiteralProps = typeParam.members;
  emitsTypeLiteralProps.forEach((prop) => {
    const propName = getTSTypeLiteralPropertySignatureName(prop);
    vineCompFnCtx.emits.push(propName);
  });
  if (parentVarDecl) {
    vineCompFnCtx.emitsAlias = parentVarDecl.id.name;
  }
};
var analyzeVineBindings = (analyzeCtx, fnItselfNode) => {
  const { vineFileCtx, vineCompFnCtx } = analyzeCtx;
  const notContainsMacroStatements = [];
  const fnBody = fnItselfNode.body;
  if (!_types.isBlockStatement.call(void 0, fnBody)) {
    return;
  }
  for (const stmt of fnBody.body) {
    let hasMacroCall = false;
    _breakableTraverse(stmt, (node) => {
      if (isVineMacroCallExpression(node)) {
        hasMacroCall = true;
        throw exitTraverse;
      }
    });
    if (!hasMacroCall) {
      notContainsMacroStatements.push(stmt);
    }
  }
  for (const stmt of notContainsMacroStatements) {
    const isAllLiteral = analyzeVineFnBodyStmtForBindings(analyzeCtx, stmt);
    if (isAllLiteral) {
      vineCompFnCtx.hoistSetupStmts.push(stmt);
    }
  }
  for (const [importName, {
    isType,
    isNamespace,
    isDefault,
    source
  }] of Object.entries(vineFileCtx.userImports)) {
    if (isType) {
      continue;
    }
    const isSetupConst = isNamespace || isDefault && source.endsWith(".vue") || source === "vue";
    vineCompFnCtx.bindings[importName] = isSetupConst ? VineBindingTypes.SETUP_CONST : VineBindingTypes.SETUP_MAYBE_REF;
  }
  const allTopLevelDeclStmts = vineFileCtx.root.program.body.filter((stmt) => _types.isDeclaration.call(void 0, stmt));
  for (const declStmt of allTopLevelDeclStmts) {
    if (isVineCompFnDecl(declStmt)) {
      const { fnName } = getFunctionInfo(declStmt);
      vineCompFnCtx.bindings[fnName] = VineBindingTypes.SETUP_CONST;
    } else if (_types.isVariableDeclaration.call(void 0, declStmt)) {
      for (const decl of declStmt.declarations) {
        if (_types.isVariableDeclarator.call(void 0, decl) && _types.isIdentifier.call(void 0, decl.id)) {
          vineCompFnCtx.bindings[decl.id.name] = VineBindingTypes.LITERAL_CONST;
        }
      }
    } else if ((_types.isFunctionDeclaration.call(void 0, declStmt) || _types.isClassDeclaration.call(void 0, declStmt)) && declStmt.id) {
      vineCompFnCtx.bindings[declStmt.id.name] = VineBindingTypes.LITERAL_CONST;
    }
  }
};
var analyzeVineStyle = ({ vineFileCtx, vineCompFnCtx }, fnItselfNode) => {
  let vineStyleMacroCall;
  _breakableTraverse(fnItselfNode, (node) => {
    if (isVineStyle(node)) {
      vineStyleMacroCall = node;
      throw exitTraverse;
    }
  });
  if (!vineStyleMacroCall) {
    return;
  }
  const macroCalleeName = getVineMacroCalleeName(vineStyleMacroCall);
  const vineStyleArg = vineStyleMacroCall.arguments[0];
  if (!vineStyleArg) {
    return;
  }
  const { styleLang, styleSource, range } = getVineStyleSource(
    vineStyleArg
  );
  const styleMeta = {
    lang: styleLang,
    source: styleSource,
    range,
    scoped: macroCalleeName === "vineStyle.scoped",
    fileCtx: vineFileCtx,
    compCtx: vineCompFnCtx
  };
  if (vineCompFnCtx.scopeId) {
    vineFileCtx.styleDefine[vineCompFnCtx.scopeId] = styleMeta;
  }
  const cssvarsValueList = parseCssVars([styleSource]);
  if (cssvarsValueList.length > 0) {
    !vineCompFnCtx.cssBindings && (vineCompFnCtx.cssBindings = {});
    cssvarsValueList.forEach((value) => {
      vineCompFnCtx.cssBindings[value] = _hashsum2.default.call(void 0, `${vineCompFnCtx.fnName}__${value}`);
    });
  }
};
var analyzeVineCustomElement = ({ vineCompFnCtx }, fnItselfNode) => {
  _breakableTraverse(fnItselfNode, (node) => {
    if (isVineCustomElement(node)) {
      vineCompFnCtx.isCustomElement = true;
      throw exitTraverse;
    }
  });
};
var analyzeVineSlots = ({ vineCompFnCtx }, fnItselfNode) => {
  let vineSlotsMacroCall;
  let parentVarDecl;
  _breakableTraverse(fnItselfNode, (node, parent) => {
    if (isVineSlots(node)) {
      vineSlotsMacroCall = node;
      const foundVarDeclAncestor = parent.find((ancestor) => _types.isVariableDeclarator.call(void 0, ancestor.node));
      parentVarDecl = _optionalChain([foundVarDeclAncestor, 'optionalAccess', _58 => _58.node]);
      throw exitTraverse;
    }
  });
  if (!vineSlotsMacroCall) {
    return;
  }
  const typeParam = _optionalChain([vineSlotsMacroCall, 'access', _59 => _59.typeParameters, 'optionalAccess', _60 => _60.params, 'access', _61 => _61[0]]);
  if (!typeParam) {
    return;
  }
  const slotsTypeLiteralProps = typeParam.members;
  for (const prop of slotsTypeLiteralProps) {
    if (_types.isTSPropertySignature.call(void 0, prop) && _types.isIdentifier.call(void 0, prop.key)) {
      const fnFirstParamType = _optionalChain([prop, 'access', _62 => _62.typeAnnotation, 'access', _63 => _63.typeAnnotation, 'optionalAccess', _64 => _64.parameters, 'optionalAccess', _65 => _65[0], 'optionalAccess', _66 => _66.typeAnnotation, 'optionalAccess', _67 => _67.typeAnnotation]);
      if (fnFirstParamType) {
        vineCompFnCtx.slots[prop.key.name] = {
          props: fnFirstParamType
        };
      }
    } else if (_types.isTSMethodSignature.call(void 0, prop) && _types.isIdentifier.call(void 0, prop.key)) {
      const fnFirstParamType = prop.parameters[0].typeAnnotation.typeAnnotation;
      vineCompFnCtx.slots[prop.key.name] = {
        props: fnFirstParamType
      };
    }
  }
  if (parentVarDecl && _types.isIdentifier.call(void 0, parentVarDecl.id)) {
    vineCompFnCtx.slotsAlias = parentVarDecl.id.name;
  }
};
var analyzeVineModel = ({ vineCompFnCtx }, fnItselfNode) => {
  const vineModelMacroCalls = [];
  _breakableTraverse(fnItselfNode, (node, parent) => {
    if (isVineModel(node)) {
      const foundVarDeclAncestor = parent.find((ancestor) => _types.isVariableDeclarator.call(void 0, ancestor.node));
      vineModelMacroCalls.push({
        macroCall: node,
        parentVarDecl: _optionalChain([foundVarDeclAncestor, 'optionalAccess', _68 => _68.node])
      });
    }
  });
  for (const { macroCall, parentVarDecl } of vineModelMacroCalls) {
    if (!parentVarDecl || !_types.isIdentifier.call(void 0, parentVarDecl.id)) {
      continue;
    }
    const varName = parentVarDecl.id.name;
    if (!macroCall.arguments.length) {
      vineCompFnCtx.vineModels.modelValue = {
        varName,
        modelModifiersName: DEFAULT_MODEL_MODIFIERS_NAME,
        modelOptions: null
      };
      continue;
    } else if (macroCall.arguments.length === 1) {
      if (_types.isStringLiteral.call(void 0, macroCall.arguments[0])) {
        const modelName = macroCall.arguments[0].value;
        vineCompFnCtx.vineModels[modelName] = {
          varName,
          modelModifiersName: `${modelName}Modifiers`,
          modelOptions: null
        };
      } else {
        vineCompFnCtx.vineModels.modelValue = {
          varName,
          modelModifiersName: DEFAULT_MODEL_MODIFIERS_NAME,
          modelOptions: macroCall.arguments[0]
        };
      }
    } else {
      const modelName = macroCall.arguments[0].value;
      vineCompFnCtx.vineModels[modelName] = {
        varName,
        modelModifiersName: `${modelName}Modifiers`,
        modelOptions: macroCall.arguments[1]
      };
    }
  }
  for (const [modelName, modelDef] of Object.entries(vineCompFnCtx.vineModels)) {
    vineCompFnCtx.bindings[modelName] = VineBindingTypes.PROPS;
    vineCompFnCtx.bindings[modelDef.varName] = VineBindingTypes.SETUP_REF;
  }
};
var analyzeRunners = [
  analyzeVineProps,
  analyzeVineEmits,
  analyzeVineExpose,
  analyzeVineSlots,
  analyzeVineModel,
  analyzeVineOptions,
  analyzeVineBindings,
  analyzeVineStyle,
  analyzeVineCustomElement
];
function analyzeDifferentKindVineFunctionDecls(analyzeCtx) {
  const { vineCompFnCtx } = analyzeCtx;
  const { fnItselfNode } = vineCompFnCtx;
  if (!fnItselfNode) {
    return;
  }
  analyzeRunners.forEach((exec) => exec(analyzeCtx, fnItselfNode));
}
function analyzeFileImportStmts(vineFileCtx) {
  const { root } = vineFileCtx;
  const fileImportStmts = getImportStatements(root);
  if (!fileImportStmts.length) {
    return;
  }
  for (const importStmt of fileImportStmts) {
    const source = importStmt.source.value;
    const isImportTypeStmt = importStmt.importKind === "type";
    const allSpecifiers = importStmt.specifiers;
    for (const spec of allSpecifiers) {
      const importMeta = {
        source,
        isType: isImportTypeStmt
      };
      if (_types.isImportSpecifier.call(void 0, spec)) {
        const importedName = _types.isStringLiteral.call(void 0, spec.imported) ? spec.imported.value : spec.imported.name;
        const localName = spec.local.name;
        if (spec.importKind === "type") {
          importMeta.isType = true;
        } else if (importedName === "default") {
          importMeta.isDefault = true;
        }
        if (source === "vue") {
          vineFileCtx.vueImportAliases[importedName] = localName || importedName;
        }
        vineFileCtx.userImports[localName] = importMeta;
      } else if (_types.isImportNamespaceSpecifier.call(void 0, spec)) {
        importMeta.isNamespace = true;
        vineFileCtx.userImports[spec.local.name] = importMeta;
      } else if (_types.isImportDefaultSpecifier.call(void 0, spec)) {
        importMeta.isDefault = true;
        vineFileCtx.userImports[spec.local.name] = importMeta;
      }
      const isUsedInTemplate = vineFileCtx.vineCompFns.some(
        (vineCompFn) => isImportUsed(vineCompFn, spec.local.name)
      );
      importMeta.isUsedInTemplate = isUsedInTemplate;
    }
  }
  const lastImportStmt = fileImportStmts[fileImportStmts.length - 1];
  vineFileCtx.importsLastLine = lastImportStmt.loc;
}
function buildVineCompFnCtx(vineCompilerHooks, vineFileCtx, fnDeclNode) {
  const { fnName, fnItselfNode } = getFunctionInfo(fnDeclNode);
  const {
    templateReturn,
    templateStringNode
  } = findVineTagTemplateStringReturn(
    fnDeclNode
  );
  const scopeId = _hashsum2.default.call(void 0, `${vineFileCtx.fileId}:${fnName}`);
  const templateStringQuasiNode = _optionalChain([templateStringNode, 'optionalAccess', _69 => _69.quasi, 'access', _70 => _70.quasis, 'access', _71 => _71[0]]);
  const templateSource = _nullishCoalesce(_optionalChain([templateStringQuasiNode, 'optionalAccess', _72 => _72.value, 'access', _73 => _73.raw]), () => ( ""));
  const vineCompFnCtx = {
    isExport: _types.isExportDeclaration.call(void 0, fnDeclNode),
    isAsync: _nullishCoalesce(_optionalChain([fnItselfNode, 'optionalAccess', _74 => _74.async]), () => ( false)),
    isCustomElement: false,
    fnName,
    scopeId,
    fnDeclNode,
    fnItselfNode,
    templateStringNode,
    templateReturn,
    templateSource,
    propsAlias: "props",
    emitsAlias: "emits",
    props: {},
    emits: [],
    slots: {},
    slotsAlias: "slots",
    vineModels: {},
    bindings: {},
    cssBindings: {},
    hoistSetupStmts: []
  };
  const analyzeCtx = {
    vineCompilerHooks,
    vineFileCtx,
    vineCompFnCtx
  };
  analyzeDifferentKindVineFunctionDecls(analyzeCtx);
  return vineCompFnCtx;
}
function analyzeVine(vineCompilerHooks, vineFileCtx, vineCompFnDecls) {
  analyzeFileImportStmts(vineFileCtx);
  vineCompFnDecls.forEach(
    (vineFnCompDecl) => {
      vineFileCtx.vineCompFns.push(
        buildVineCompFnCtx(
          vineCompilerHooks,
          vineFileCtx,
          vineFnCompDecl
        )
      );
    }
  );
  const makeErrorOnRefHoistedIdentifiers = (vineFnComp, identifiers) => {
    for (const id of identifiers) {
      const binding = vineFnComp.bindings[id.name];
      if (binding && binding !== VineBindingTypes.LITERAL_CONST) {
        vineCompilerHooks.onError(
          vineWarn(vineFileCtx, {
            msg: `Cannot reference "${id.name}" locally declared variables because it will be hoisted outside of component's setup() function.`,
            location: id.loc
          })
        );
      }
    }
  };
  for (const vineFnComp of vineFileCtx.vineCompFns) {
    const allValidatorFnBodys = Object.entries(vineFnComp.props).filter(([_, propMeta]) => Boolean(propMeta.validator)).map(([_, propMeta]) => propMeta.validator.body);
    for (const validatorFnBody of allValidatorFnBodys) {
      const identifiers = [];
      _compilerdom.walkIdentifiers.call(void 0, validatorFnBody, (id) => identifiers.push(id));
      makeErrorOnRefHoistedIdentifiers(vineFnComp, identifiers);
    }
    const vineOptionsArg = vineFnComp.options;
    if (vineOptionsArg) {
      const identifiers = [];
      _compilerdom.walkIdentifiers.call(void 0, vineOptionsArg, (id) => identifiers.push(id));
      makeErrorOnRefHoistedIdentifiers(vineFnComp, identifiers);
    }
    if (vineFnComp.vineModels) {
      for (const { modelOptions } of Object.values(vineFnComp.vineModels)) {
        if (!modelOptions) {
          continue;
        }
        const identifiers = [];
        _compilerdom.walkIdentifiers.call(void 0, modelOptions, (id) => identifiers.push(id));
        makeErrorOnRefHoistedIdentifiers(vineFnComp, identifiers);
      }
    }
  }
}

// src/transform.ts










// src/template/traverse.ts
function traverseNode(node, filter, callback) {
  const children = node.children;
  if (!filter(node)) {
    return;
  }
  callback(node);
  if (Array.isArray(children)) {
    for (const childNode of children) {
      traverseNode(childNode, filter, callback);
    }
  }
}
function traverseTemplate(templateAstRootNode, filter, callback) {
  for (const childNode of templateAstRootNode.children) {
    traverseNode(childNode, filter, callback);
  }
}

// src/template/type-predicate.ts
function isTemplateElementNode(node) {
  return node.type === 1;
}
function isComponentNode(node) {
  return node.type === 1 && node.tagType === 1;
}

// src/style/create-import-statement.ts
function createStyleImportStmt(vineFileCtx, vineCompFnCtx, styleDefine) {
  const styleLangExt = getStyleLangFileExt(styleDefine.lang);
  return `import ${showIf(
    // handle web component styles
    Boolean(vineCompFnCtx.isCustomElement),
    `__${vineCompFnCtx.fnName.toLowerCase()}_styles from `
  )}'${vineFileCtx.fileId.replace(/\.vine\.ts$/, "")}?type=vine-style&scopeId=${vineCompFnCtx.scopeId}&comp=${vineCompFnCtx.fnName}&lang=${styleDefine.lang}${showIf(
    Boolean(styleDefine.scoped),
    "&scoped=true"
  )}&virtual.${styleLangExt}';`;
}

// src/style/order.ts
function topoSort(relationsMap) {
  const visited = {};
  const sorted = [];
  function dfs(node, stack) {
    if (stack[node]) {
      return null;
    }
    if (visited[node])
      return;
    visited[node] = true;
    stack[node] = true;
    for (const depNode of relationsMap[node]) {
      const result = dfs(depNode, stack);
      if (result === null) {
        return null;
      }
    }
    stack[node] = false;
    sorted.push(node);
  }
  for (const node of Object.keys(relationsMap)) {
    dfs(node, {});
  }
  if (sorted.length !== Object.keys(visited).length) {
    return null;
  }
  return sorted;
}
function sortStyleImport(vineFileCtx) {
  const { vineCompFns, styleDefine } = vineFileCtx;
  const relationsMap = Object.fromEntries(
    vineCompFns.map(
      (compFnCtx) => [compFnCtx.fnName, /* @__PURE__ */ new Set()]
    )
  );
  for (const compFnCtx of vineCompFns) {
    const templateAstRootNode = compFnCtx.templateAst;
    if (!templateAstRootNode) {
      continue;
    }
    traverseTemplate(templateAstRootNode, (templateAstNode) => isTemplateElementNode(templateAstNode) && isComponentNode(templateAstNode), (templateAstNode) => {
      relationsMap[compFnCtx.fnName].add(
        templateAstNode.tag
      );
    });
  }
  const sortedStyleImportStmts = (_nullishCoalesce(_optionalChain([topoSort, 'call', _75 => _75(relationsMap), 'optionalAccess', _76 => _76.map, 'call', _77 => _77(
    (compName) => vineCompFns.find(
      (compFn) => compFn.fnName === compName
    )
  )]), () => ( []))).filter(
    (fnCompCtx) => Boolean(styleDefine[fnCompCtx.scopeId])
  ).map(
    (fnCompCtx) => [fnCompCtx, styleDefine[fnCompCtx.scopeId]]
  ).map(
    ([fnCompCtx, styleMeta]) => createStyleImportStmt(
      vineFileCtx,
      fnCompCtx,
      styleMeta
    )
  );
  return sortedStyleImportStmts;
}

// src/template/compose.ts


var _linecolumn = require('line-column'); var _linecolumn2 = _interopRequireDefault(_linecolumn);

// src/babel-helpers/parse.ts

function babelParse(code, options = {}) {
  const finalOptions = {
    sourceType: "module",
    plugins: ["typescript"],
    errorRecovery: true,
    ...options
  };
  try {
    return _parser.parse.call(void 0, code, finalOptions);
  } catch (err) {
    return _parser.parse.call(void 0, "", finalOptions);
  }
}

// src/template/compose.ts
function compileVineTemplate(source, params) {
  return _compilerdom.compile.call(void 0, source, {
    mode: "module",
    hoistStatic: true,
    cacheHandlers: true,
    inline: true,
    ...params
  });
}
function saveImportSpecifier(mergedImportsMap, importStmts) {
  for (const importStmt of importStmts) {
    const allImportSpecs = importStmt.specifiers;
    const source = importStmt.source.value;
    for (const spec of allImportSpecs) {
      if (_types.isImportSpecifier.call(void 0, spec)) {
        const specName = _types.isIdentifier.call(void 0, spec.imported) ? spec.imported.name : spec.imported.value;
        const specAlias = _types.isIdentifier.call(void 0, spec.local) ? spec.local.name : specName;
        const specMeta = mergedImportsMap.get(source);
        if (!specMeta) {
          mergedImportsMap.set(
            source,
            {
              type: "namedSpecifier",
              specs: /* @__PURE__ */ new Map([[specName, specAlias]])
            }
          );
        } else {
          specMeta.specs.set(specName, specAlias);
        }
      } else if (_types.isImportDefaultSpecifier.call(void 0, spec)) {
        mergedImportsMap.set(
          source,
          {
            type: "defaultSpecifier",
            localName: spec.local.name
          }
        );
      } else {
        mergedImportsMap.set(
          source,
          {
            type: "namespaceSpecifier",
            localName: spec.local.name
          }
        );
      }
    }
  }
}
function isExportRenderFnNode(node) {
  if (!_types.isExportNamedDeclaration.call(void 0, node)) {
    return false;
  }
  return _types.isFunctionDeclaration.call(void 0, node.declaration) && _optionalChain([node, 'access', _78 => _78.declaration, 'access', _79 => _79.id, 'optionalAccess', _80 => _80.name]) === "render";
}
function getQuasisNode(vineFnCompCtx) {
  return _optionalChain([vineFnCompCtx, 'access', _81 => _81.templateStringNode, 'optionalAccess', _82 => _82.quasi, 'access', _83 => _83.quasis, 'access', _84 => _84[0]]);
}
function computeTemplateErrLocation(vineFileCtx, vineFnCompCtx, errLocation) {
  const quasisNode = getQuasisNode(vineFnCompCtx);
  if (!quasisNode) {
    return;
  }
  const mapper = _linecolumn2.default.call(void 0, 
    vineFileCtx.fileMagicCode.original,
    { origin: 1 }
    // Babel line/column is 1-based
  );
  const templateStart = quasisNode.start;
  const startOffset = templateStart + errLocation.start.offset;
  const endOffset = templateStart + errLocation.end.offset;
  const start = mapper.fromIndex(startOffset);
  const end = mapper.fromIndex(endOffset);
  if (!start || !end) {
    return;
  }
  const [startColumn, endColumn] = start.line === end.line && start.col === end.col ? [1, Number.POSITIVE_INFINITY] : [start.col, end.col];
  const loc = {
    identifierName: errLocation.source,
    filename: vineFileCtx.fileId,
    start: {
      line: start.line,
      column: startColumn,
      index: startOffset
    },
    end: {
      line: end.line,
      column: endColumn,
      index: endOffset
    }
  };
  return loc;
}
function createSeparatedTemplateComposer(compilerHooks) {
  const templateCompileResults = /* @__PURE__ */ new WeakMap();
  const generatedPreambleStmts = /* @__PURE__ */ new WeakMap();
  return {
    templateCompileResults,
    generatedPreambleStmts,
    compileSetupFnReturns: ({
      vineFileCtx,
      vineCompFnCtx: vineFnCompCtx,
      templateSource,
      mergedImportsMap,
      bindingMetadata
    }) => {
      let hasTemplateCompileErr = false;
      const compileResult = compileVineTemplate(
        templateSource,
        {
          ..._nullishCoalesce(_optionalChain([compilerHooks, 'access', _85 => _85.getCompilerCtx, 'call', _86 => _86(), 'optionalAccess', _87 => _87.options, 'optionalAccess', _88 => _88.vueCompilerOptions]), () => ( {})),
          scopeId: `data-v-${vineFnCompCtx.scopeId}`,
          bindingMetadata,
          inline: false,
          onError: (e) => {
            if (hasTemplateCompileErr) {
              return;
            }
            hasTemplateCompileErr = true;
            compilerHooks.onError(
              vineErr(
                vineFileCtx,
                {
                  msg: `[Vine template compile error] ${e.message}`,
                  location: e.loc && computeTemplateErrLocation(vineFileCtx, vineFnCompCtx, e.loc)
                }
              )
            );
          },
          onWarn: (e) => {
            compilerHooks.onWarn(
              vineWarn(
                vineFileCtx,
                {
                  msg: `[Vine template compile warning] ${e.message}`,
                  location: e.loc && computeTemplateErrLocation(vineFileCtx, vineFnCompCtx, e.loc)
                }
              )
            );
          }
        }
      );
      vineFnCompCtx.templateAst = hasTemplateCompileErr ? void 0 : _compilerdom.parse.call(void 0, templateSource);
      if (hasTemplateCompileErr) {
        return "";
      }
      const { code } = compileResult;
      const generatedCodeAst = babelParse(code);
      saveImportSpecifier(
        mergedImportsMap,
        generatedCodeAst.program.body.filter(
          (stmt) => _types.isImportDeclaration.call(void 0, stmt)
        )
      );
      let exportRenderFnNode;
      for (const codeStmt of generatedCodeAst.program.body) {
        if (_types.isImportDeclaration.call(void 0, codeStmt)) {
          continue;
        } else if (isExportRenderFnNode(codeStmt)) {
          exportRenderFnNode = codeStmt;
          continue;
        }
        appendToMapArray(
          generatedPreambleStmts,
          vineFnCompCtx,
          code.slice(
            codeStmt.start,
            codeStmt.end
          )
        );
      }
      if (!exportRenderFnNode) {
        compilerHooks.onError(vineErr(vineFileCtx, {
          msg: "[Vine Error] Cannot find export render function on template composing"
        }));
        return "";
      }
      templateCompileResults.set(
        vineFnCompCtx,
        code.slice(
          exportRenderFnNode.start,
          exportRenderFnNode.end
        ).replace(
          "export function render",
          "function __sfc_render"
        )
      );
      const allBindings = { ...bindingMetadata };
      for (const key in vineFileCtx.userImports) {
        if (!vineFileCtx.userImports[key].isType && vineFileCtx.userImports[key].isUsedInTemplate) {
          allBindings[key] = true;
        }
      }
      let setupFnReturns = "{ ";
      for (const key in allBindings) {
        if (allBindings[key] === true && vineFileCtx.userImports[key].source !== "vue" && !vineFileCtx.userImports[key].source.endsWith(".vue")) {
          setupFnReturns += `get ${key}() { return ${key} }, `;
        } else if (bindingMetadata[key] === VineBindingTypes.SETUP_LET) {
          const setArg = key === "v" ? "_v" : "v";
          setupFnReturns += `get ${key}() { return ${key} }, set ${key}(${setArg}) { ${key} = ${setArg} }, `;
        } else if (bindingMetadata[key] === VineBindingTypes.PROPS) {
        } else {
          setupFnReturns += `${key}, `;
        }
      }
      setupFnReturns = `${setupFnReturns.replace(/, $/, "")} }`;
      return setupFnReturns;
    }
  };
}
function createInlineTemplateComposer(compilerHooks) {
  const templateCompileResults = /* @__PURE__ */ new WeakMap();
  const generatedPreambleStmts = /* @__PURE__ */ new WeakMap();
  return {
    templateCompileResults,
    generatedPreambleStmts,
    compileSetupFnReturns: ({
      vineFileCtx,
      vineCompFnCtx,
      templateSource,
      mergedImportsMap,
      bindingMetadata
    }) => {
      let hasTemplateCompileErr = false;
      const compileResult = compileVineTemplate(
        templateSource,
        {
          ..._nullishCoalesce(_optionalChain([compilerHooks, 'access', _89 => _89.getCompilerCtx, 'call', _90 => _90(), 'optionalAccess', _91 => _91.options, 'optionalAccess', _92 => _92.vueCompilerOptions]), () => ( {})),
          scopeId: `data-v-${vineCompFnCtx.scopeId}`,
          bindingMetadata,
          onError: (e) => {
            if (hasTemplateCompileErr) {
              return;
            }
            hasTemplateCompileErr = true;
            compilerHooks.onError(
              vineErr(
                vineFileCtx,
                {
                  msg: `[Vine template compile error] ${e.message}`,
                  location: e.loc && computeTemplateErrLocation(vineFileCtx, vineCompFnCtx, e.loc)
                }
              )
            );
          },
          onWarn: (e) => {
            compilerHooks.onWarn(
              vineWarn(
                vineFileCtx,
                {
                  msg: `[Vine template compile warning] ${e.message}`,
                  location: e.loc && computeTemplateErrLocation(vineFileCtx, vineCompFnCtx, e.loc)
                }
              )
            );
          }
        }
      );
      const { preamble, code, ast } = compileResult;
      vineCompFnCtx.templateAst = ast;
      if (hasTemplateCompileErr) {
        return "";
      }
      const preambleAst = babelParse(preamble);
      saveImportSpecifier(
        mergedImportsMap,
        preambleAst.program.body.filter(
          (stmt) => _types.isImportDeclaration.call(void 0, stmt)
        )
      );
      const preambleStmts = preambleAst.program.body.filter(
        (stmt) => !_types.isImportDeclaration.call(void 0, stmt)
      );
      preambleStmts.forEach((stmt) => appendToMapArray(
        generatedPreambleStmts,
        vineCompFnCtx,
        preamble.slice(
          stmt.start,
          stmt.end
        )
      ));
      templateCompileResults.set(vineCompFnCtx, code);
      return code;
    }
  };
}

// src/style/transform-css-var.ts


function findIdentifierFromExp(scriptContent) {
  const identifiers = [];
  const ast = babelParse(scriptContent);
  _types.traverse.call(void 0, ast, (node) => {
    if (node.type === "Identifier") {
      identifiers.push(node);
    }
  });
  return identifiers;
}
function genCSSVarsList(cssBindings, propsAlias, bindings, inline = false) {
  let res = "";
  if (cssBindings) {
    for (const cssBindScriptContent in cssBindings) {
      const cssBindValue = cssBindings[cssBindScriptContent];
      const ms = new (0, _magicstring2.default)(cssBindScriptContent);
      const cssBindKeySgNodes = findIdentifierFromExp(cssBindScriptContent);
      cssBindKeySgNodes.forEach((node) => {
        ms.overwrite(
          node.start,
          node.end,
          // non-inline mode only needs to rewrite the variable to `_ctx.x`
          inline ? genCSSVarsValue(ms, node, bindings, propsAlias) : `_ctx.${cssBindScriptContent.slice(
            node.start,
            node.end
          )}`
        );
      });
      res = `${res}  '${cssBindValue}': (${ms.toString()}),
`;
    }
  }
  return res;
}
function genCSSVarsValue(ms, node, bindings, propsAlias) {
  let res = "";
  const nodeContent = ms.original.slice(
    node.start,
    node.end
  );
  for (const bindingsKey in bindings) {
    const bindingValue = bindings[bindingsKey];
    if (nodeContent === bindingsKey) {
      switch (bindingValue) {
        case VineBindingTypes.PROPS:
        case VineBindingTypes.PROPS_ALIASED:
          res = `${propsAlias}.${nodeContent}`;
          break;
        case VineBindingTypes.SETUP_CONST:
        case VineBindingTypes.SETUP_REACTIVE_CONST:
        case VineBindingTypes.LITERAL_CONST:
          res = nodeContent;
          break;
        case VineBindingTypes.SETUP_MAYBE_REF:
        case VineBindingTypes.SETUP_LET:
          res = `_unref(${nodeContent})`;
          break;
        case VineBindingTypes.SETUP_REF:
          res = `${nodeContent}.value`;
          break;
        default:
          res = `_ctx.${nodeContent}`;
      }
    }
  }
  return res;
}
function compileCSSVars(vineCompFnCtx, inline = false) {
  const {
    cssBindings,
    propsAlias,
    bindings
  } = vineCompFnCtx;
  if (!cssBindings)
    return "";
  const varList = genCSSVarsList(
    cssBindings,
    propsAlias,
    bindings,
    inline
  );
  return `_${CSS_VARS_HELPER}(_ctx => ({
${varList}
}))`;
}

// src/transform.ts
function wrapWithAsyncContext(isNeedResult, exprSourceCode) {
  return isNeedResult ? `;(
    ([__temp,__restore] = _withAsyncContext(() => ${exprSourceCode})),
    await __temp,
    __restore()
  );` : `;(
    ([__temp,__restore] = _withAsyncContext(() => ${exprSourceCode})),
    __temp = await __temp,
    __restore(),
    __temp
  );`;
}
function mayContainAwaitExpr(targetNode) {
  let awaitExpr;
  if (!(_types.isVariableDeclaration.call(void 0, targetNode) || _types.isAssignmentExpression.call(void 0, targetNode) || _types.isExpressionStatement.call(void 0, targetNode))) {
    return false;
  }
  try {
    _types.traverse.call(void 0, targetNode, (descendant) => {
      if (_types.isAwaitExpression.call(void 0, descendant)) {
        awaitExpr = descendant;
        throw new Error(EXPECTED_ERROR);
      }
    });
  } catch (error) {
    if (error === EXPECTED_ERROR) {
      return awaitExpr;
    }
    throw error;
  }
}
function registerImport(mergedImportsMap, importSource, specifier, alias) {
  const vueVineImports = mergedImportsMap.get(importSource);
  if (!vueVineImports) {
    mergedImportsMap.set(importSource, {
      type: "namedSpecifier",
      specs: /* @__PURE__ */ new Map([[specifier, alias]])
    });
  } else {
    const vueImportsSpecs = vueVineImports.specs;
    vueImportsSpecs.set(specifier, alias);
  }
}
function setupCodeGenerationForVineModel(vineFnCompCtx) {
  let modelCodeGen = [];
  for (const [modelName, modelDef] of Object.entries(vineFnCompCtx.vineModels)) {
    const { varName } = modelDef;
    modelCodeGen.push(
      `const ${varName} = _${USE_MODEL_HELPER}(__props, '${modelName}')`
    );
  }
  return `
${modelCodeGen.join("\n")}
`;
}
function propsOptionsCodeGeneration(vineFileCtx, vineCompFnCtx) {
  const segementsFromProps = Object.entries(vineCompFnCtx.props).map(([propName, propMeta]) => {
    const metaFields = [];
    if (propMeta.isRequired) {
      metaFields.push("required: true");
    }
    if (propMeta.isBool) {
      metaFields.push("type: Boolean");
    }
    if (propMeta.validator) {
      metaFields.push(`validator: ${vineFileCtx.originCode.slice(
        propMeta.validator.start,
        propMeta.validator.end
      )}`);
    }
    return `${propName}: { ${showIf(
      metaFields.filter(Boolean).length > 0,
      filterJoin(metaFields, ", "),
      "/* Simple prop */"
    )} },`;
  });
  const segementsFromVineModel = Object.entries(vineCompFnCtx.vineModels).reduce((segments, [modelName, modelDef]) => {
    const { modelModifiersName, modelOptions } = modelDef;
    segments.push(
      `${modelName}: ${modelOptions ? vineFileCtx.originCode.slice(
        modelOptions.start,
        modelOptions.end
      ) : "{}"},`
    );
    segments.push(
      `${modelModifiersName}: {},`
    );
    return segments;
  }, []);
  return [
    ...segementsFromProps,
    ...segementsFromVineModel
  ];
}
function transformFile(vineFileCtx, compilerHooks, inline = true) {
  const isDev = compilerHooks.getCompilerCtx().options.envMode !== "production";
  const ms = vineFileCtx.fileMagicCode;
  const styleImportStmts = sortStyleImport(vineFileCtx);
  const mergedImportsMap = /* @__PURE__ */ new Map();
  let isPrependedUseDefaults = false;
  const {
    templateCompileResults,
    generatedPreambleStmts,
    compileSetupFnReturns
  } = inline ? createInlineTemplateComposer(compilerHooks) : createSeparatedTemplateComposer(compilerHooks);
  for (const vineCompFnCtx of vineFileCtx.vineCompFns) {
    const setupFnReturns = compileSetupFnReturns({
      vineFileCtx,
      vineCompFnCtx,
      templateSource: vineCompFnCtx.templateSource,
      mergedImportsMap,
      bindingMetadata: vineCompFnCtx.bindings
    });
    const isNeedUseDefaults = Object.values(vineCompFnCtx.props).some((meta) => Boolean(meta.default));
    let vueImportsMeta = mergedImportsMap.get("vue");
    if (!vueImportsMeta) {
      vueImportsMeta = {
        type: "namedSpecifier",
        specs: /* @__PURE__ */ new Map()
      };
      mergedImportsMap.set("vue", vueImportsMeta);
    }
    const vueImportsSpecs = vueImportsMeta.specs;
    if (!vueImportsSpecs.has(DEFINE_COMPONENT_HELPER)) {
      vueImportsSpecs.set(DEFINE_COMPONENT_HELPER, `_${DEFINE_COMPONENT_HELPER}`);
    }
    if (!vueImportsSpecs.has(CSS_VARS_HELPER) && vineCompFnCtx.cssBindings) {
      vueImportsSpecs.set(CSS_VARS_HELPER, `_${CSS_VARS_HELPER}`);
      inline && vueImportsSpecs.set(UN_REF_HELPER, `_${UN_REF_HELPER}`);
    }
    if (Object.entries(vineCompFnCtx.slots).length > 0) {
      vueImportsSpecs.set(USE_SLOT_HELPER, `_${USE_SLOT_HELPER}`);
    }
    const vineCompFnStart = vineCompFnCtx.fnDeclNode.start;
    const vineCompFnEnd = vineCompFnCtx.fnDeclNode.end;
    const vineCompFnBody = vineCompFnCtx.fnItselfNode.body;
    if (_types.isBlockStatement.call(void 0, vineCompFnBody)) {
      let hasAwait = false;
      for (const vineFnBodyStmt of vineCompFnBody.body) {
        const isContained = mayContainAwaitExpr(vineFnBodyStmt);
        if (!isContained) {
          continue;
        }
        hasAwait = true;
        ms.update(
          vineFnBodyStmt.start,
          vineFnBodyStmt.end,
          wrapWithAsyncContext(
            _types.isExpressionStatement.call(void 0, vineFnBodyStmt),
            ms.original.slice(
              vineFnBodyStmt.start,
              vineFnBodyStmt.end
            )
          )
        );
      }
      const firstStmt = vineCompFnBody.body[0];
      const lastStmt = vineCompFnBody.body[vineCompFnBody.body.length - 1];
      ms.remove(vineCompFnStart, firstStmt.start);
      ms.remove(lastStmt.end, vineCompFnEnd);
      vineCompFnBody.body.forEach((stmt) => {
        if (isStatementContainsVineMacroCall(stmt) || _types.isReturnStatement.call(void 0, stmt)) {
          ms.remove(stmt.start, stmt.end);
        }
      });
      const setupCtxDestructFormalParams = [];
      if (vineCompFnCtx.emits.length > 0) {
        setupCtxDestructFormalParams.push({
          field: "emits",
          alias: vineCompFnCtx.emitsAlias
        });
      }
      setupCtxDestructFormalParams.push({
        field: "expose",
        alias: "__expose"
      });
      let setupFormalParams = `__props${setupCtxDestructFormalParams.length > 0 ? `, { ${setupCtxDestructFormalParams.map(
        ({ field, alias }) => `${field}${showIf(Boolean(alias), `: ${alias}`)}`
      ).join(", ")} }` : " /* No setup ctx destructuring */"}`;
      if (Object.entries(vineCompFnCtx.slots).length > 0) {
        ms.prependLeft(
          firstStmt.start,
          `const ${vineCompFnCtx.slotsAlias} = _${USE_SLOT_HELPER}();
`
        );
      }
      if (Object.entries(vineCompFnCtx.vineModels).length > 0) {
        registerImport(
          mergedImportsMap,
          "vue",
          USE_MODEL_HELPER,
          `_${USE_MODEL_HELPER}`
        );
        ms.prependLeft(
          firstStmt.start,
          setupCodeGenerationForVineModel(vineCompFnCtx)
        );
      }
      if (Array.from(
        Object.entries(vineCompFnCtx.cssBindings)
      ).length > 0) {
        ms.prependLeft(
          firstStmt.start,
          `
${compileCSSVars(vineCompFnCtx, inline)}
`
        );
      }
      if (Object.values(vineCompFnCtx.props).some((meta) => Boolean(meta.isFromMacroDefine))) {
        registerImport(
          mergedImportsMap,
          "vue",
          TO_REFS_HELPER,
          `_${TO_REFS_HELPER}`
        );
        const propsFromMacro = Object.entries(vineCompFnCtx.props).filter(([_, meta]) => Boolean(meta.isFromMacroDefine)).map(([propName, _]) => propName);
        ms.prependLeft(
          firstStmt.start,
          `const { ${propsFromMacro.join(", ")} } = _toRefs(${vineCompFnCtx.propsAlias});
`
        );
      }
      let propsDeclarationStmt = `const ${vineCompFnCtx.propsAlias} = __props;`;
      if (isNeedUseDefaults && !isPrependedUseDefaults) {
        isPrependedUseDefaults = true;
        registerImport(
          mergedImportsMap,
          "vue-vine",
          USE_DEFAULTS_HELPER,
          `_${USE_DEFAULTS_HELPER}`
        );
        propsDeclarationStmt = `const ${vineCompFnCtx.propsAlias} = _${USE_DEFAULTS_HELPER}(__props, {
${Object.entries(vineCompFnCtx.props).filter(([_, propMeta]) => Boolean(propMeta.default)).map(([propName, propMeta]) => `  ${propName}: ${ms.original.slice(
          propMeta.default.start,
          propMeta.default.end
        )}`).join(",\n")}
})
`;
      }
      ms.prependLeft(
        firstStmt.start,
        propsDeclarationStmt
      );
      if (hasAwait) {
        ms.prependLeft(
          firstStmt.start,
          "let __temp, __restore;\n"
        );
      }
      vineCompFnCtx.expose ? ms.appendRight(
        lastStmt.end,
        `
__expose(${ms.original.slice(
          vineCompFnCtx.expose.start,
          vineCompFnCtx.expose.end
        )});
`
      ) : ms.prependLeft(
        firstStmt.start,
        "\n__expose();\n"
      );
      ms.appendRight(lastStmt.end, `
return ${setupFnReturns};`);
      ms.prependLeft(firstStmt.start, `setup(${setupFormalParams}) {
`);
      ms.appendRight(lastStmt.end, "\n}");
      const emitsKeys = [
        ...vineCompFnCtx.emits.map((emit) => `'${emit}'`),
        ...Object.keys(vineCompFnCtx.vineModels).map((modelName) => `'update:${modelName}'`)
      ];
      const propsOptionFields = propsOptionsCodeGeneration(
        vineFileCtx,
        vineCompFnCtx
      );
      ms.prependLeft(firstStmt.start, `const __vine = _defineComponent({
${// Some basic component options
      vineCompFnCtx.options ? `...${ms.original.slice(
        vineCompFnCtx.options.start,
        vineCompFnCtx.options.end
      )},` : `name: '${vineCompFnCtx.fnName}',`}
${propsOptionFields.length > 0 ? `props: {
${propsOptionsCodeGeneration(
        vineFileCtx,
        vineCompFnCtx
      ).join("\n")}
},` : "/* No props */"}
${emitsKeys.length > 0 ? `emits: [${emitsKeys.join(", ")}],` : "/* No emits */"}
`);
      ms.appendRight(lastStmt.end, "\n})");
      ms.prependLeft(firstStmt.start, `
export const ${vineCompFnCtx.fnName} = (() => {
${// Prepend all generated preamble statements
      _nullishCoalesce(_optionalChain([generatedPreambleStmts, 'access', _93 => _93.get, 'call', _94 => _94(vineCompFnCtx), 'optionalAccess', _95 => _95.join, 'call', _96 => _96("\n")]), () => ( ""))}
`);
      ms.appendRight(lastStmt.end, `
${inline ? "" : `${_nullishCoalesce(templateCompileResults.get(vineCompFnCtx), () => ( ""))}
__vine.render = __sfc_render`}
${showIf(
        Boolean(vineFileCtx.styleDefine[vineCompFnCtx.scopeId]),
        `__vine.__scopeId = 'data-v-${vineCompFnCtx.scopeId}';`
      )}
${isDev ? `__vine.__hmrId = '${vineCompFnCtx.scopeId}';` : ""}
${showIf(
        // handle Web Component styles
        Boolean(vineCompFnCtx.isCustomElement),
        `__vine.styles = [__${vineCompFnCtx.fnName.toLowerCase()}_styles];
`
      )}
return __vine
})();`);
      if (isDev) {
        ms.appendRight(
          ms.length(),
          `

typeof __VUE_HMR_RUNTIME__ !== "undefined" && __VUE_HMR_RUNTIME__.createRecord(${vineCompFnCtx.fnName}.__hmrId, ${vineCompFnCtx.fnName});
`
        );
      }
    }
  }
  if (isDev) {
    ms.appendRight(
      ms.length(),
      `export const _rerender_only = ${vineFileCtx.renderOnly}
export const _rerender_vcf_fn_name = ${vineFileCtx.hmrCompFnsName ? `"${vineFileCtx.hmrCompFnsName}"` : '""'}
import.meta.hot.accept((mod) => {
if (!mod){return;}
const { _rerender_only, _rerender_vcf_fn_name } = mod;
if (!_rerender_vcf_fn_name){return;}
const component = mod[_rerender_vcf_fn_name];
if (_rerender_only) {
  __VUE_HMR_RUNTIME__.rerender(component.__hmrId, component.render);
} else {
  __VUE_HMR_RUNTIME__.reload(component.__hmrId, component);
}
});`
    );
  }
  ms.prepend(`
${styleImportStmts.join("\n")}
`);
  for (const [importSource, importMeta] of mergedImportsMap) {
    if (importMeta.type === "namedSpecifier") {
      const { specs } = importMeta;
      const specifiers = [...specs.entries()];
      const importStmt = `import { ${specifiers.map(
        ([specifier, alias]) => `${specifier}${showIf(Boolean(alias), ` as ${alias}`)}`
      ).join(", ")} } from '${importSource}';
`;
      ms.prepend(importStmt);
    } else if (importMeta.type === "defaultSpecifier") {
      const importStmt = `import ${importMeta.localName} from '${importSource}';
`;
      ms.prepend(importStmt);
    } else if (importMeta.type === "namespaceSpecifier") {
      const importStmt = `import * as ${importMeta.localName} from '${importSource}';
`;
      ms.prepend(importStmt);
    }
  }
}

// src/style/compile.ts
var _postcss = require('postcss'); var _postcss2 = _interopRequireDefault(_postcss);

// src/style/preprocessor.ts
var _mergesourcemap = require('merge-source-map'); var _mergesourcemap2 = _interopRequireDefault(_mergesourcemap);
var scss = (source, map, options, load = __require) => {
  const nodeSass = load("sass");
  const finalOptions = {
    ...options,
    data: source,
    sourceMap: Boolean(map)
  };
  try {
    const result = nodeSass.renderSync(finalOptions);
    const dependencies = result.stats.includedFiles;
    if (map) {
      return {
        code: result.css.toString(),
        map: _mergesourcemap2.default.call(void 0, map, JSON.parse(result.map.toString())),
        errors: [],
        dependencies
      };
    }
    return { code: result.css.toString(), errors: [], dependencies };
  } catch (e) {
    return { code: "", errors: [e], dependencies: [] };
  }
};
var sass = (source, map, options, load = __require) => scss(
  source,
  map,
  {
    ...options,
    indentedSyntax: true
  },
  load
);
var less = (source, map, options, load = __require) => {
  const nodeLess = load("less");
  let result;
  let error = null;
  nodeLess.render(
    source,
    { ...options, syncImport: true },
    (err, output) => {
      error = err;
      result = output;
    }
  );
  if (error)
    return { code: "", errors: [error], dependencies: [] };
  const dependencies = result.imports;
  if (map) {
    return {
      code: result.css.toString(),
      map: _mergesourcemap2.default.call(void 0, map, result.map),
      errors: [],
      dependencies
    };
  }
  return {
    code: result.css.toString(),
    errors: [],
    dependencies
  };
};
var stylus = (source, map, options, load = __require) => {
  const nodeStylus = load("stylus");
  try {
    const ref = nodeStylus(source);
    Object.keys(options).forEach((key) => ref.set(key, options[key]));
    if (map)
      ref.set("sourcemap", { inline: false, comment: false });
    const result = ref.render();
    const dependencies = ref.deps();
    if (map) {
      return {
        code: result,
        map: _mergesourcemap2.default.call(void 0, map, ref.sourcemap),
        errors: [],
        dependencies
      };
    }
    return { code: result, errors: [], dependencies };
  } catch (e) {
    return { code: "", errors: [e], dependencies: [] };
  }
};
var processors = {
  less,
  sass,
  scss,
  stylus
};

// src/style/scoped-plugin.ts
var _postcssselectorparser = require('postcss-selector-parser'); var _postcssselectorparser2 = _interopRequireDefault(_postcssselectorparser);
var animationNameRE = /^(-\w+-)?animation-name$/;
var animationRE = /^(-\w+-)?animation$/;
var processedRules = /* @__PURE__ */ new WeakSet();
var scopedPlugin = (options) => {
  const { id = "", fileCtx, compilerCtx } = _nullishCoalesce(options, () => ( {}));
  const keyframes = /* @__PURE__ */ Object.create(null);
  const shortId = id.replace(/^data-v-/, "");
  function onPluginWarn(params) {
    _optionalChain([compilerCtx, 'optionalAccess', _97 => _97.vineCompileWarnings, 'access', _98 => _98.push, 'call', _99 => _99(
      vineWarn(fileCtx, params)
    )]);
  }
  function processRule(id2, rule) {
    if (processedRules.has(rule) || rule.parent && rule.parent.type === "atrule" && /-?keyframes$/.test(rule.parent.name)) {
      return;
    }
    processedRules.add(rule);
    rule.selector = _postcssselectorparser2.default.call(void 0, (selectorRoot) => {
      selectorRoot.each((selector) => {
        rewriteSelector(id2, selector, selectorRoot);
      });
    }).processSync(rule.selector);
  }
  function rewriteSelector(id2, selector, selectorRoot, slotted = false) {
    let node = null;
    let shouldInject = true;
    selector.each((n) => {
      if (n.type === "combinator" && (n.value === ">>>" || n.value === "/deep/")) {
        n.value = " ";
        n.spaces.before = n.spaces.after = "";
        onPluginWarn({
          msg: "the >>> and /deep/ combinators have been deprecated. Use :deep() instead.",
          location: null
        });
        return false;
      }
      if (n.type === "pseudo") {
        const { value } = n;
        if (value === ":deep" || value === "::v-deep") {
          if (n.nodes.length) {
            let last = n;
            n.nodes[0].each((ss) => {
              selector.insertAfter(last, ss);
              last = ss;
            });
            const prev = selector.at(selector.index(n) - 1);
            if (!prev || !isSpaceCombinator(prev)) {
              selector.insertAfter(
                n,
                _postcssselectorparser2.default.combinator({
                  value: " "
                })
              );
            }
            selector.removeChild(n);
          } else {
            onPluginWarn({
              msg: "::v-deep usage as a combinator has been deprecated. Use :deep(<inner-selector>) instead.",
              location: null
            });
            const prev = selector.at(selector.index(n) - 1);
            if (prev && isSpaceCombinator(prev)) {
              selector.removeChild(prev);
            }
            selector.removeChild(n);
          }
          return false;
        }
        if (value === ":slotted" || value === "::v-slotted") {
          rewriteSelector(
            id2,
            n.nodes[0],
            selectorRoot,
            true
            /* slotted */
          );
          let last = n;
          n.nodes[0].each((ss) => {
            selector.insertAfter(last, ss);
            last = ss;
          });
          selector.removeChild(n);
          shouldInject = false;
          return false;
        }
        if (value === ":global" || value === "::v-global") {
          selectorRoot.insertAfter(selector, n.nodes[0]);
          selectorRoot.removeChild(selector);
          return false;
        }
      }
      if (n.type !== "pseudo" && n.type !== "combinator") {
        node = n;
      }
    });
    if (node) {
      node.spaces.after = "";
    } else {
      selector.first.spaces.before = "";
    }
    if (shouldInject) {
      const idToAdd = slotted ? `${id2}-s` : id2;
      selector.insertAfter(
        // If node is null it means we need to inject [id] at the start
        // insertAfter can handle `null` here
        node,
        _postcssselectorparser2.default.attribute({
          attribute: idToAdd,
          value: idToAdd,
          raws: {},
          quoteMark: '"'
        })
      );
    }
  }
  function isSpaceCombinator(node) {
    return node.type === "combinator" && /^\s+$/.test(node.value);
  }
  return {
    postcssPlugin: "vine-style-scoped",
    Rule(rule) {
      processRule(id, rule);
    },
    AtRule(node) {
      if (/-?keyframes$/.test(node.name) && !node.params.endsWith(`-${shortId}`)) {
        keyframes[node.params] = node.params = `${node.params}-${shortId}`;
      }
    },
    OnceExit(root) {
      if (Object.keys(keyframes).length) {
        root.walkDecls((decl) => {
          if (animationNameRE.test(decl.prop)) {
            decl.value = decl.value.split(",").map((v) => keyframes[v.trim()] || v.trim()).join(",");
          }
          if (animationRE.test(decl.prop)) {
            decl.value = decl.value.split(",").map((v) => {
              const vals = v.trim().split(/\s+/);
              const i = vals.findIndex((val) => keyframes[val]);
              if (i !== -1) {
                vals.splice(i, 1, keyframes[vals[i]]);
                return vals.join(" ");
              } else {
                return v;
              }
            }).join(",");
          }
        });
      }
    }
  };
};
scopedPlugin.postcss = true;

// src/style/trim-plugin.ts
var trimPlugin = () => {
  return {
    postcssPlugin: "vine-style-trim",
    Once(root) {
      root.walk(({ type, raws }) => {
        if (type === "rule" || type === "atrule") {
          if (raws.before)
            raws.before = "\n";
          if ("after" in raws && raws.after)
            raws.after = "\n";
        }
      });
    }
  };
};
trimPlugin.postcss = true;

// src/style/css-vars-plugin.ts

var cssVarsPlugin = (options) => {
  const { vineCompFns } = options.fileCtx;
  let cssBindings = {};
  vineCompFns.some((fnComp) => {
    if (fnComp.scopeId === options.scopeId) {
      cssBindings = fnComp.cssBindings;
      return true;
    }
    return false;
  });
  return {
    postcssPlugin: "vine-style-css-vars",
    Once(root) {
      root.walk((ctx) => {
        if (ctx.type === "decl" && ctx.value && ctx.value.includes("v-bind")) {
          for (const cbKey in cssBindings) {
            const range = {
              start: null,
              end: null
            };
            const content = parseCssVars([ctx.value], {
              getIndex(start, end) {
                range.start = start;
                range.end = end;
              }
            });
            if (content[0] === cbKey) {
              const mg = new (0, _magicstring2.default)(ctx.value);
              mg.overwrite(range.start, range.end, `--${cssBindings[cbKey]}`);
              mg.replaceAll("v-bind", "var");
              ctx.value = mg.toString();
              break;
            }
          }
        }
      });
    }
  };
};
cssVarsPlugin.postcss = true;

// src/style/compile.ts
async function compileVineStyle(compilerCtx, params) {
  let { source } = params;
  const {
    vineFileId,
    isScoped,
    scopeId,
    preprocessLang,
    inputSourceMap,
    preprocessOptions = _nullishCoalesce(compilerCtx.options.preprocessOptions, () => ( {})),
    postcssOptions = compilerCtx.options.postcssOptions,
    postcssPlugins: userPostcssPlugins = _nullishCoalesce(compilerCtx.options.postcssPlugins, () => ( []))
  } = params;
  const preprocessor = preprocessLang && processors[preprocessLang];
  const preProcessedSource = _optionalChain([preprocessor, 'optionalCall', _100 => _100(
    source,
    inputSourceMap,
    preprocessOptions
  )]);
  const map = preProcessedSource ? preProcessedSource.map : inputSourceMap;
  if (preProcessedSource) {
    source = preProcessedSource.code;
  }
  const postcssPlugins = [
    trimPlugin(),
    ...userPostcssPlugins
  ];
  if (isScoped) {
    const shortId = scopeId.replace(/^data-v-/, "");
    const longId = `data-v-${shortId}`;
    postcssPlugins.push(
      scopedPlugin({
        compilerCtx,
        id: longId,
        fileCtx: compilerCtx.fileCtxMap.get(vineFileId)
      })
    );
  }
  if (source.includes("v-bind")) {
    postcssPlugins.push(cssVarsPlugin({
      fileCtx: compilerCtx.fileCtxMap.get(vineFileId),
      scopeId
    }));
  }
  const postCSSOptions = {
    ...postcssOptions,
    // prevent warnings, we don't need file name
    from: void 0,
    to: void 0
  };
  if (map) {
    postCSSOptions.map = {
      inline: false,
      annotation: false,
      prev: map
    };
  }
  const errors = [];
  if (preProcessedSource && preProcessedSource.errors.length) {
    errors.push(...preProcessedSource.errors);
  }
  const dependencies = new Set(
    preProcessedSource ? preProcessedSource.dependencies : []
  );
  const recordPlainCssDependencies = (messages) => {
    messages.forEach((msg) => {
      if (msg.type === "dependency") {
        dependencies.add(msg.file);
      }
    });
    return dependencies;
  };
  const result = _postcss2.default.call(void 0, postcssPlugins).process(source, postCSSOptions);
  return result.then((result2) => ({
    code: result2.css || "",
    map: result2.map && result2.map.toJSON(),
    errors,
    rawResult: result2,
    dependencies: recordPlainCssDependencies(result2.messages)
  })).catch((error) => ({
    code: "",
    map: void 0,
    errors: [...errors, error],
    rawResult: void 0,
    dependencies
  }));
}

// src/index.ts
function createCompilerCtx(options = {}) {
  return {
    fileCtxMap: /* @__PURE__ */ new Map(),
    vineCompileErrors: [],
    vineCompileWarnings: [],
    isRunningHMR: false,
    options: {
      inlineTemplate: true,
      // default inline template
      // Maybe some default options ...
      ...options
    }
  };
}
function createVineFileCtx(code, fileId, fileCtxCache) {
  const root = babelParse(code);
  const vineFileCtx = {
    root,
    fileId,
    renderOnly: fileCtxCache ? fileCtxCache.renderOnly : false,
    hmrCompFnsName: fileCtxCache ? fileCtxCache.hmrCompFnsName : null,
    isCRLF: code.includes("\r\n"),
    fileMagicCode: new (0, _magicstring2.default)(code),
    vineCompFns: [],
    userImports: {},
    styleDefine: {},
    vueImportAliases: {},
    get originCode() {
      return this.fileMagicCode.original;
    }
  };
  return vineFileCtx;
}
function doValidateVine(vineCompilerHooks, vineFileCtx, vineCompFnDecls) {
  validateVine(vineCompilerHooks, vineFileCtx, vineCompFnDecls);
  _optionalChain([vineCompilerHooks, 'access', _101 => _101.onValidateEnd, 'optionalCall', _102 => _102()]);
}
function doAnalyzeVine(vineCompilerHooks, vineFileCtx, vineCompFnDecls) {
  analyzeVine(vineCompilerHooks, vineFileCtx, vineCompFnDecls);
  _optionalChain([vineCompilerHooks, 'access', _103 => _103.onAnalysisEnd, 'optionalCall', _104 => _104()]);
}
function compileVineTypeScriptFile(code, fileId, compilerHooks, fileCtxCache) {
  const compilerOptions = compilerHooks.getCompilerCtx().options;
  const vineFileCtx = createVineFileCtx(code, fileId, fileCtxCache);
  _optionalChain([compilerHooks, 'access', _105 => _105.onBindFileCtx, 'optionalCall', _106 => _106(fileId, vineFileCtx)]);
  const vineCompFnDecls = findVineCompFnDecls(vineFileCtx.root);
  doValidateVine(compilerHooks, vineFileCtx, vineCompFnDecls);
  doAnalyzeVine(compilerHooks, vineFileCtx, vineCompFnDecls);
  transformFile(
    vineFileCtx,
    compilerHooks,
    _nullishCoalesce(_optionalChain([compilerOptions, 'optionalAccess', _107 => _107.inlineTemplate]), () => ( true))
  );
  return vineFileCtx;
}








exports.compileVineStyle = compileVineStyle; exports.compileVineTypeScriptFile = compileVineTypeScriptFile; exports.createCompilerCtx = createCompilerCtx; exports.createVineFileCtx = createVineFileCtx; exports.doAnalyzeVine = doAnalyzeVine; exports.doValidateVine = doValidateVine; exports.findVineCompFnDecls = findVineCompFnDecls;
